/*
	chg_exp.c		xbrush

	x-window ¸ߤʤؿ
*/
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;      /*  󥽡ѡ  */

static unsigned char full[16][16] =
  {{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}};

static unsigned char half[16][16] =
  {{1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1},
   {1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0},
   {0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1}};


/*  ɥɽΰΰ  */
void Wget_wrk(Widget wid, RECT *rect)
{
  Display *dsp;
  Window win, root;
  int x, y;
  unsigned int width, height;
  unsigned int border_width, depth;

  dsp = XtDisplay( wid );
  win = XtWindow( wid );

  XGetGeometry( dsp, win, &root, &x, &y, &width, &height,
                                                    &border_width, &depth );
                                            /*  ɥΰ֤Ĵ٤  */
  rect->c.left = 0;
  rect->c.right = width;
  rect->c.top = 0;
  rect->c.bottom = height;
}

/*  ɥɽΰа  */
void Wfnd_wnd(Widget wid, RECT *rect)
{
  Display *dsp;
  Window win, root, win1, win2, *win_ch;
  int x, y, x1, y1;
  unsigned int width, height, dm_width, dm_height;
  unsigned int border_width, depth, num;

  dsp = XtDisplay( wid );
  win = XtWindow( wid );

  XGetGeometry( dsp, win, &root, &x1, &y1, &width, &height,
                                                    &border_width, &depth );
                                            /*  ɥΰ֤Ĵ٤  */
  x = x1; y = y1;
  win1 = win;

  while(win1 != root) /*  롼ȥɥľޤ̤äư֤Ĵ٤  */
  {
    XQueryTree( dsp, win1, &root, &win2, &win_ch, &num);
                             /*  ƥɥҥɥΥꥹȤ  */

    XGetGeometry( dsp, win1, &root, &x1, &y1, &dm_width, &dm_height,
                                                    &border_width, &depth );
                                            /*  ɥΰ֤Ĵ٤  */
    x += x1; y += y1;
    win1 = win2;
  }

  rect->c.left = x;
  rect->c.right = width + x;
  rect->c.top = y;
  rect->c.bottom = height + y;
}

/*  ѡĤͤ  */
void Cset_val(Widget w, int size, int *value)
{
  Arg args[1];
  char str[4];

  XtSetArg(args[0], XtNvalue, &str);
  XtGetValues(w, args, 1);
  sprintf(str, "%3d", *value);
  XtSetArg(args[0], XtNlabel, str);
  XtSetValues(w, args, 1);
}

/*  ĶΰĴ٤  */
void Gget_fra(XImage *image, RECT *rect)
{
  rect->c.left = 0;
  rect->c.right = image->width;
  rect->c.top = 0;
  rect->c.bottom = image->height;
}

/*  ɽɤĤ֤  */
void Gfil_rec(XImage *image, RECT rect, PAT *pat, int angle, char mode)
{                                   /*  angle ϴطʤ  */
  int pixel_byte, width, height, x, y, cnt_x, cnt_y;
  unsigned char  col[3];

  pixel_byte = (image->bits_per_pixel + 7) / 8;

  width  = image->width;
  height = image->height;

  cnt_x = 0; cnt_y = 0;

  col[0] = pat->spat.fgcol & 0xFF;
  col[1] = (pat->spat.fgcol >> 8) & 0xFF;
  col[2] = (pat->spat.fgcol >> 16) & 0xFF;

  if( rect.c.right > width )
    rect.c.right = width;
  if( rect.c.bottom > height )
    rect.c.bottom = height;

  for( y = rect.c.top; y < rect.c.bottom; y++ )
  {
    for( x = rect.c.left; x < rect.c.right; x++ )
    {
      /*XPutPixel(image, x, y, color);  /*  ̤  */

      if(pat->spat.mask == 100 ||
                 (pat->spat.mask == 50 && half[cnt_x][cnt_y] > 0))
      {
        memset(image->data + (x * pixel_byte + y * image->bytes_per_line),
	                                        col[0], 1);
        memset(image->data + (x * pixel_byte + 1 + y * image->bytes_per_line),
	                                        col[1], 1);
        memset(image->data + (x * pixel_byte + 2 + y * image->bytes_per_line),
	                                        col[2], 1);
      }
      cnt_x += 1;
      if(cnt_x > 15) cnt_x = 0;
    }
    cnt_y += 1;
    if(cnt_y > 15) cnt_y = 0;
  }
}

/*  硿̾ԡ  */
void Gcop_bmp(XImage *src_xim, RECT *src_rect, XImage *dst_xim, RECT *dst_rect,
                                                          char *mask, int mode)
{
  /*  src_bmp  src_rect ϰϤ dst_bmp  dst_rect إԡ  */

  float  x_s, y_s, dx, dy;
  int  x_d, y_d, sw, sh, dw, dh;
  int  adrx_s, adrx_d, adry_s, adry_d;
  int  databyte_s, databyte_d;
  int  count_x_s, count_y_s, pixbyte;
  int  offsetx_s, offsetx_d;

  sw = src_rect->c.right - src_rect->c.left;
  sh = src_rect->c.bottom - src_rect->c.top;
  dw = dst_rect->c.right - dst_rect->c.left;
  dh = dst_rect->c.bottom - dst_rect->c.top;

  dx = (float)sw / (float)dw;
  dy = (float)sh / (float)dh;

  //databyte_s = (((src_xim->bits_per_pixel + 15) / 8) / 2) * 2;
  //databyte_d = (((dst_xim->bits_per_pixel + 15) / 8) / 2) * 2;
  databyte_s = (src_xim->bits_per_pixel + 7) / 8;
  databyte_d = (dst_xim->bits_per_pixel + 7) / 8;
                      /*  ԥ˲ХȤΥǡȤäƤ뤫  */

  offsetx_s = src_rect->c.left * databyte_s;
  offsetx_d = dst_rect->c.left * databyte_d;
                                            /*  ǡɥ쥹X  */
  adry_s = src_rect->c.top * src_xim->bytes_per_line;
  adry_d = dst_rect->c.top * dst_xim->bytes_per_line;
                                           /*  ǡɥ쥹Y  */
  count_x_s = src_rect->c.left;
  count_y_s = src_rect->c.top;
  pixbyte = src_xim->bits_per_pixel / 8;  /*  ԥ벿ХȤ  */

  y_s = src_rect->c.top;
  for(y_d = dst_rect->c.top; y_d < dst_rect->c.bottom; y_d ++)
  {  /*  ԡ y ɸΥ롼  */
    adrx_s = offsetx_s;  /*  ǡɥ쥹X  */
    adrx_d = offsetx_d;
    x_s = src_rect->c.left;
    count_x_s = src_rect->c.left;
    for(x_d = dst_rect->c.left; x_d < dst_rect->c.right; x_d ++)
    {  /*  ԡ x ɸΥ롼  */
      if(count_x_s != (int)x_s)
      {  /*  ԡΥǡɤ߹߰(x)1ľ夬äȤ  */
        count_x_s = (int)x_s;
        adrx_s += databyte_s;
      }
      memcpy((dst_xim->data + adrx_d + adry_d),
                       (src_xim->data + adrx_s + adry_s), pixbyte );
      adrx_d += databyte_d;
      x_s += dx;
    }
    y_s += dy;
    if(count_y_s != (int)y_s)
    {  /*  ԡΥǡɤ߹߰(y)1ľ夬äȤ  */
      count_y_s = (int)y_s;
      adry_s += src_xim->bytes_per_line;
    }
    adry_d += dst_xim->bytes_per_line;
  }
}
