/*
	initcons.C		xbrush

	󥽡륦ɥν
*/
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

/*  RGBͤȤ߹碌  */
unsigned long Getcolor(Display *dsp,
                   unsigned char r, unsigned char g, unsigned char b)
{
  unsigned long c_pixel;

  c_pixel = r << 16 | g << 8 | b;

  return( c_pixel );
}

/*  ɸɽͥܥåν  */
void Init_pos(Widget cons_wid, POINTPNT *point_pnt, unsigned int nbox_fmt)
{
  XFontStruct *fnt;    /*  Font Struct */

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  point_pnt->numx_rect.c.left   =  20; point_pnt->numx_rect.c.top  =  4;
  point_pnt->numx_rect.c.right  =  point_pnt->numx_rect.c.left + 30;
  point_pnt->numx_rect.c.bottom =  point_pnt->numx_rect.c.top + 18;

  point_pnt->numy_rect.c.left   =  74; point_pnt->numy_rect.c.top  =  4;
  point_pnt->numy_rect.c.right  =  point_pnt->numy_rect.c.left + 30;
  point_pnt->numy_rect.c.bottom =  point_pnt->numy_rect.c.top + 18;

  point_pnt->numx_pid =
                XtVaCreateManagedWidget("numx", labelWidgetClass,
					cons_wid,
			    XtNhorizDistance, point_pnt->numx_rect.c.left,
			    XtNvertDistance,  point_pnt->numx_rect.c.top,
			    XtNwidth,         point_pnt->numx_rect.c.right
                                                 - point_pnt->numx_rect.c.left,
			    XtNheight,        point_pnt->numx_rect.c.bottom
                                                 - point_pnt->numx_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
			    XtNlabel,  (XtArgVal)"0",
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */
  point_pnt->numy_pid =
                XtVaCreateManagedWidget("numy", labelWidgetClass,
			    cons_wid,
			    XtNhorizDistance, point_pnt->numy_rect.c.left,
			    XtNvertDistance,  point_pnt->numy_rect.c.top,
			    XtNwidth,         point_pnt->numy_rect.c.right
                                                 - point_pnt->numy_rect.c.left,
			    XtNheight,        point_pnt->numy_rect.c.bottom
                                                 - point_pnt->numy_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
			    XtNlabel,  (XtArgVal)"0",
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */

}

/*  ɥåν  */
void Init_undosw(Widget cons_wid, SWPART *mswpart)
{
  static char  msw_txt[] = {"Undo"};
  static  char  defaultTranslations[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";
  XtTranslations trans_table;

  XFontStruct *fnt;    /*  Font Struct */

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  mswpart->sw_rect.c.left   =  4;
  mswpart->sw_rect.c.top    =  82;
  mswpart->sw_rect.c.right  =  mswpart->sw_rect.c.left + 47;
  mswpart->sw_rect.c.bottom =  mswpart->sw_rect.c.top + 18;

  mswpart->sw_pid  =  XtVaCreateManagedWidget(msw_txt, commandWidgetClass,
			    cons_wid,
			    XtNhorizDistance, mswpart->sw_rect.c.left,
			    XtNvertDistance,  mswpart->sw_rect.c.top,
			    XtNwidth,         mswpart->sw_rect.c.right
                                                 - mswpart->sw_rect.c.left,
			    XtNheight,        mswpart->sw_rect.c.bottom
                                                 - mswpart->sw_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel, (XtArgVal)msw_txt,
			    XtNfont,    fnt,
			    XtNbackground,  LGRAY,
			    NULL);
                                         /*  ɥå  */

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(mswpart->sw_pid, trans_table);
                                            /*  ȥ󥹥졼  */

  XtAddCallback(mswpart->sw_pid, XtNcallback, (XtCallbackProc)Exec_undo, NULL);
                                            /*  ХåϿ  */
}

/*  ɥååν  */
void Init_locksw(Widget cons_wid, SWPART *aswpart, int cv)
{
  static char  asw_txt[] = {"Lock"};

  XFontStruct *fnt;    /*  Font Struct */

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  aswpart->sw_rect.c.left   =  4;
  aswpart->sw_rect.c.top    =  82;
  aswpart->sw_rect.c.right  =  aswpart->sw_rect.c.left + 47;
  aswpart->sw_rect.c.bottom =  aswpart->sw_rect.c.top + 18;

  aswpart->sw_pid = XtVaCreateManagedWidget(asw_txt, toggleWidgetClass,
			    cons_wid,
			    XtNhorizDistance, aswpart->sw_rect.c.left,
			    XtNvertDistance,  aswpart->sw_rect.c.top,
			    XtNwidth,         aswpart->sw_rect.c.right
                                                 - aswpart->sw_rect.c.left,
			    XtNheight,        aswpart->sw_rect.c.bottom
                                                 - aswpart->sw_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel, (XtArgVal)asw_txt,
			    XtNfromHoriz,  consparts->mswpart.sw_pid,
			    XtNfont,    fnt,
			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ɥåå  */

  XtAddCallback(aswpart->sw_pid, XtNcallback, (XtCallbackProc)Undo_lock, NULL);
                                            /*  ХåϿ  */
}

/*  Ψν  */
void Init_zoom(Widget cons_wid, NUMPART *zoom_num, unsigned int nbox_fmt,
                                                                     int zoom)
{
  XFontStruct *fnt;    /*  Font Struct */

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  zoom_num->num_rect.c.left   =  68; zoom_num->num_rect.c.top  =  30;
  zoom_num->num_rect.c.right  =  zoom_num->num_rect.c.left + 20;
  zoom_num->num_rect.c.bottom =  zoom_num->num_rect.c.top + 18;

  zoom_num->num_pid =
                XtVaCreateManagedWidget("zoom_num", labelWidgetClass,
			    cons_wid,
			    XtNhorizDistance, zoom_num->num_rect.c.left,
			    XtNvertDistance,  zoom_num->num_rect.c.top,
			    XtNwidth,         zoom_num->num_rect.c.right
                                                 - zoom_num->num_rect.c.left,
			    XtNheight,        zoom_num->num_rect.c.bottom
                                                 - zoom_num->num_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel,   (XtArgVal)"1",
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */
}

/*  ؿɽν  */
void Init_func(FUNCVAL *funcval)
{
    int    i;

    funcval->func_rect.c.left   =   5;
    funcval->func_rect.c.top    = 110;
    funcval->func_rect.c.right  = C_WIDTH - 5;
    funcval->func_rect.c.bottom = funcval->func_rect.c.top + 140;

    funcval->xaxi.c.left   =  funcval->func_rect.c.left   + 10;
    funcval->xaxi.c.top    =  funcval->func_rect.c.top    + 20;
    funcval->xaxi.c.right  =  funcval->xaxi.c.left;
    funcval->xaxi.c.bottom =  funcval->func_rect.c.bottom - 10;

    funcval->yaxi.c.left   =  funcval->func_rect.c.left   +  5;
    funcval->yaxi.c.top    =  funcval->func_rect.c.bottom - 20;
    funcval->yaxi.c.right  =  funcval->func_rect.c.right  -  5;
    funcval->yaxi.c.bottom =  funcval->yaxi.c.top;
    for( i = 0 ; i < 257 ; i ++ )
    {    /*  ֥饷ޥåפΥ  */
        funcval->brush_map[i] = malloc(32761 * sizeof(unsigned char));
    }
    for( i = 0 ; i < 32761 ; i ++ )
    {
        *(funcval->brush_map[256] + i) = 255;
    }
}

/*  ֥饷ǻɽν  */
void Init_dens(Widget cons_wid, VOLPARAM *dens_vol, unsigned int nbox_fmt)
{
  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  XFontStruct *fnt;    /*  Font Struct */

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Console_Evt, NULL},
    {NULL, NULL},
  };

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  dens_vol->num_rect.c.left   =  66; dens_vol->num_rect.c.top  =  260;
  dens_vol->num_rect.c.right  =  dens_vol->num_rect.c.left + 30;
  dens_vol->num_rect.c.bottom =  dens_vol->num_rect.c.top + 16;
                                                    /*  ͥܥåΰ  */

  dens_vol->vol_rect.c.left   = 4;
  dens_vol->vol_rect.c.top    = dens_vol->num_rect.c.bottom + 6;
  dens_vol->vol_rect.c.right  = dens_vol->vol_rect.c.left + 100;
  dens_vol->vol_rect.c.bottom = dens_vol->vol_rect.c.top + 16;
                                                    /*  ܥ塼ΰ  */

  dens_vol->num_pid = XtVaCreateManagedWidget("dens_el", labelWidgetClass,
			    cons_wid,
			    XtNlabel, (XtArgVal)"dens",
			    XtNhorizDistance, dens_vol->num_rect.c.left,
			    XtNvertDistance,  dens_vol->num_rect.c.top,
			    XtNwidth,         dens_vol->num_rect.c.right
                                                 - dens_vol->num_rect.c.left,
			    XtNheight,        dens_vol->num_rect.c.bottom
                                                 - dens_vol->num_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel,   (XtArgVal)"1",
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */
  dens_vol->size = 1;

  dens_vol->vol_pid = XtVaCreateManagedWidget("dens", scrollbarWidgetClass,
                            cons_wid,
                            XtNorientation,(XtArgVal)XtorientHorizontal,
                            XtNlength,    (XtArgVal)100,
                            XtNthickness, (XtArgVal)16,
                            XtNjumpProc,  (XtArgVal)callback,
			    XtNhorizDistance, dens_vol->vol_rect.c.left,
			    XtNvertDistance,  dens_vol->vol_rect.c.top,
			    XtNwidth,         dens_vol->vol_rect.c.right
                                                 - dens_vol->vol_rect.c.left,
			    XtNheight,        dens_vol->vol_rect.c.bottom
                                                 - dens_vol->vol_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
 			    XtNbackground,  DGRAY,
			    NULL);
                                        /*  ܥ塼  */

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(dens_vol->vol_pid, trans_table);

}

/*  ֥饷礭ν  */
void Init_size(Widget cons_wid, VOLPARAM *size_vol, unsigned int nbox_fmt)
{
  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  XFontStruct *fnt;    /*  Font Struct */

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Console_Evt, NULL},
    {NULL, NULL},
  };

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

    size_vol->num_rect.c.left   = 66; size_vol->num_rect.c.top = 304;
    size_vol->num_rect.c.right  = size_vol->num_rect.c.left + 30;
    size_vol->num_rect.c.bottom = size_vol->num_rect.c.top + 16;
                                                    /*  ͥܥåΰ  */
    size_vol->vol_rect.c.left   = 4;
    size_vol->vol_rect.c.top    = size_vol->num_rect.c.bottom + 6;
    size_vol->vol_rect.c.right  = size_vol->vol_rect.c.left + 100;
    size_vol->vol_rect.c.bottom = size_vol->vol_rect.c.top + 16;
                                                    /*  ܥ塼ΰ  */
    size_vol->vol_val[0] = size_vol->size + NOB;
    size_vol->vol_val[1] = size_vol->size;
    size_vol->vol_val[2] = 180 + NOB;
    size_vol->vol_val[3] = 1;


  size_vol->num_pid = XtVaCreateManagedWidget("size_el",labelWidgetClass,
			    cons_wid,
			    XtNhorizDistance, size_vol->num_rect.c.left,
			    XtNvertDistance,  size_vol->num_rect.c.top,
			    XtNwidth,         size_vol->num_rect.c.right
                                                 - size_vol->num_rect.c.left,
			    XtNheight,        size_vol->num_rect.c.bottom
                                                 - size_vol->num_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel,   (XtArgVal)"1",
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */
  size_vol->size = 1;

  //Set_size_el(&cons_parts);

  size_vol->vol_pid = XtVaCreateManagedWidget("size", scrollbarWidgetClass,
			    cons_wid,
                            XtNorientation,  (XtArgVal)XtorientHorizontal,
                            XtNlength,    (XtArgVal)100,
                            XtNthickness, (XtArgVal)16,
                            XtNjumpProc,  (XtArgVal)callback,
			    XtNhorizDistance, size_vol->vol_rect.c.left,
			    XtNvertDistance,  size_vol->vol_rect.c.top,
			    XtNwidth,         size_vol->vol_rect.c.right
                                                 - size_vol->vol_rect.c.left,
			    XtNheight,        size_vol->vol_rect.c.bottom
                                                 - size_vol->vol_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
 			    XtNbackground,  DGRAY,
			    NULL);
                                        /*  ܥ塼  */

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(size_vol->vol_pid, trans_table);
}

/*  򿧥Сν  */
void Init_colbar(Widget cons_wid, VOLPARAM *col_vol, int elem,
                                                       unsigned int nbox_fmt)
{
  Display *dsp;
  unsigned long  color;
  unsigned char cd = 235, zero = 0;

  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  XFontStruct *fnt;    /*  Font Struct */

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Console_Evt, NULL},
    {NULL, NULL},
  };

  dsp = XtDisplay( cons_wid );

  fnt = XLoadQueryFont( XtDisplay( cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */
    col_vol->num_rect.c.left   = 4 + 36 * elem;
    col_vol->num_rect.c.top    = 364;
    col_vol->num_rect.c.right  = col_vol->num_rect.c.left + 28;
    col_vol->num_rect.c.bottom = col_vol->num_rect.c.top + 16;
                                                    /*  ͥܥåΰ  */
    col_vol->vol_rect.c.left   = 8 + 36 * elem;
    col_vol->vol_rect.c.top    = col_vol->num_rect.c.bottom + 4;
    col_vol->vol_rect.c.right  = col_vol->vol_rect.c.left + 20;
    col_vol->vol_rect.c.bottom = col_vol->vol_rect.c.top + C_LENG;
                                                    /*  ܥ塼ΰ  */
    col_vol->vol_val[0] = col_vol->size + NOB;
    col_vol->vol_val[1] = col_vol->size;
    col_vol->vol_val[2] = 255 + NOB;
    col_vol->vol_val[3] = 0;

  col_vol->num_pid = XtVaCreateManagedWidget("col_vol", labelWidgetClass,
			    cons_wid,
			    XtNhorizDistance, col_vol->num_rect.c.left,
			    XtNvertDistance,  col_vol->num_rect.c.top,
			    XtNwidth,         col_vol->num_rect.c.right
                                                 - col_vol->num_rect.c.left,
			    XtNheight,        col_vol->num_rect.c.bottom
                                                 - col_vol->num_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNlabel,   (XtArgVal)"255",
			    XtNjustify, XtJustifyRight,
			    XtNfont,    fnt,
 			    XtNbackground,  LGRAY,
			    NULL);
                                        /*  ͥܥå  */

  switch( elem )
  {
  case 0:
    color = Getcolor( dsp, cd, zero, zero );
    break;
  case 1:
    color = Getcolor( dsp, zero, cd, zero );
    break;
  case 2:
    color = Getcolor( dsp, zero, zero, cd );
    break;
  }

  col_vol->vol_pid = XtVaCreateManagedWidget("color_bar", scrollbarWidgetClass,
                            cons_wid,
                            XtNlength,        (XtArgVal)100,
                            XtNthickness,     (XtArgVal)16,
                            XtNjumpProc,      (XtArgVal)callback,
			    XtNbackground,    (XtArgVal)color,
			    XtNshown,         10,
			    XtNhorizDistance, col_vol->vol_rect.c.left,
			    XtNvertDistance,  col_vol->vol_rect.c.top,
			    XtNwidth,         col_vol->vol_rect.c.right
                                                 - col_vol->vol_rect.c.left,
			    XtNheight,        col_vol->vol_rect.c.bottom
                                                 - col_vol->vol_rect.c.top,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    NULL);
                                        /*  ܥ塼  */

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(col_vol->vol_pid, trans_table);
}

/*  ν  */
void Init_col(Widget cons_wid, SLCTCOL *slct_col, unsigned int nbox_fmt)
{
    int    i;

    for(i = 0; i < 3; i ++)
    {
        Init_colbar(cons_wid, &slct_col->colbar[i], i, nbox_fmt);
                                           /*  ƿСν  */
    }
    slct_col->sel_col = 0x00FFFFFF;    /*  ԥ  */
    slct_col->colbox.c.left   = 10;
    slct_col->colbox.c.top    = C_HEIGHT - 68;
    slct_col->colbox.c.right  = C_WIDTH - 10;
    slct_col->colbox.c.bottom = slct_col->colbox.c.top + 60;
                            /*  ԥͤ򥫥顼ɽΰ  */
}

/*  󥽡ΥѡĤν  */
void Init_conspt(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Init_pos(prg_id->cons_wid, &cons_parts->point_pnt, cons_parts->nbox_fmt);
                                  /*  ɸɽͥܥåν  */

  Init_undosw(prg_id->cons_wid, &cons_parts->mswpart);
                                    /*  ɥåν  */

  Init_locksw(prg_id->cons_wid, &cons_parts->aswpart, 
	                              (prg_id->xb_mode & 0x0020) ? 1 : 0);
                                    /*  ɥååν  */

  Init_zoom(prg_id->cons_wid, &cons_parts->zoom_num, 
                                         cons_parts->nbox_fmt, bmp_plm->zoom);
                                         /*  Ψν  */

  Init_dens(prg_id->cons_wid, &cons_parts->dens_vol, cons_parts->nbox_fmt);
                                          /*  ֥饷ǻɽν  */

  Init_size(prg_id->cons_wid, &cons_parts->size_vol, cons_parts->nbox_fmt);
                                          /*  ֥饷礭ν  */

  Init_col(prg_id->cons_wid, &cons_parts->slct_col, cons_parts->nbox_fmt);
                                          /*  ν  */

  Shw_color(bmp_plm, cons_parts);       /*  򿧤  */

  Init_func(&cons_parts->funcval);      /*  ؿɽν  */

  bmp_plm->b_size = cons_parts->size_vol.size;    /*  ֥饷礭  */
}
