/*
	mask.C		xbrush for Ķ

	ޥǽϢ
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern XFontStruct *info;    /*  Font Struct */

extern Widget  ordinary, reflect, drawmsk, erasemsk;
extern Widget  line2, domsk, turnmsk, automsk;

/*  ޥѥ  */
int   Make_mask_mat(BMPPALA *bmp_plm)
{
  bmp_plm->mask_mat =
        malloc(bmp_plm->org_size.h * bmp_plm->org_size.v * sizeof(char));
                                                 /*  ޥ̤  */
  memset(bmp_plm->mask_mat, 0xFF,
                    bmp_plm->org_size.h * bmp_plm->org_size.v * sizeof(char));
                                                 /*  ޥ̤ν  */
  if(bmp_plm->mask_mat == NULL)
    return(-1);

  DEBUG_PRINT(("Make_mask_mat() %d\n", (bmp_plm->org_size.h * bmp_plm->org_size.v * sizeof(char))));
  return(1);
}

/*  ޥ꡼  */
int   Make_mask_scr(BMPPALA *bmp_plm)
{
  bmp_plm->mask_scr =
            malloc(bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char));
  if(bmp_plm->mask_scr == NULL)
    return(-1);
  DEBUG_PRINT(("Make_mask_scr() %d\n", (bmp_plm->wid_size.h * bmp_plm->wid_size.v * sizeof(char))));

  Rest_mask(&bmp_plm->org_bmp.bounds, &bmp_plm->zoom_rect, bmp_plm->mask_mat,
              &bmp_plm->wid_rect, &bmp_plm->drw_rect, bmp_plm->mask_scr,
                                                                bmp_plm->zoom);
                                    /*  ޥ̤ޥ꡼  */

    return(1);
}

/*  ޥѥõ  */
void    Free_mask_mat(BMPPALA *bmp_plm)
{
    free(bmp_plm->mask_mat);
}

/*  ޥ꡼ѥõ  */
void    Free_mask_scr(BMPPALA *bmp_plm)
{
    free(bmp_plm->mask_scr);
}

/*  ɤĤ֤  */
int    Drw_Paintout(XImage *image, RECT *rect)
{
    PAT         pat = {{0, 16, 16, WHITE, 0x80000000, FILL100}};
    //PAT         pat = {{0, 16, 16, WHITE, 0x80000000, 0}};
    DCM         mode = G_STORE;    /*  ⡼  */
    int           err;

    //DEBUG_PRINT(("Drw_Paintout()\n"));
    Gfil_rec(image, *rect, &pat, 0, mode);
                                      /*  gid ɤĤ֤  */
    return(1);
}

/*  ϡեȡ  */
int    Drw_Harftone(XImage *image, RECT *rect)
{
    PAT         pat = {{0, 16, 16, WHITE, 0x80000000, FILL50}};
    //PAT         pat = {{0, 16, 16, 0x80000000, WHITE, 0}};
    DCM         mode = G_STORE;    /*  ⡼  */
    int           err;

    //DEBUG_PRINT(("Drw_Harftone()\n"));
    Gfil_rec(image, *rect, &pat, 0, mode);
                                      /*  gid ˥ϡեȡ򤫤  */
    return(1);
}

/*  ɥ̤˥ϡեȡ򤫤  */
int    Harf_tone(unsigned short mask_mode, BMPPALA *bmp_plm)
{
    DCM   mode = G_STORE | G_CVFORM | G_CVCOLOR;   /*  ⡼  */
    int     err = 0;

  DEBUG_PRINT(("Harf_tone()\n"));

    Copy_tiles(bmp_plm->org_xim, &(bmp_plm->zoom_rect),
                 bmp_plm->imag_xim, &(bmp_plm->drw_rect), bmp_plm->zoom, mode);
                                           /*  礷ƥԡ  */

    /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ  */
    if( (mask_mode & 0x00C0) == 0x0080 || (mask_mode & 0x00C0) == 0x00C0 )
    {
        if( (mask_mode & 0x0020) == 0x0000 )
            err = Drw_Harftone(bmp_plm->imag_xim, &bmp_plm->drw_rect);
                          /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                 ̤˥ϡեȡ򤫤  */
        else if( (mask_mode & 0x0020) == 0x0020 )
            err = Drw_Paintout(bmp_plm->imag_xim, &bmp_plm->drw_rect);
                          /*  ֥ޥΤɽפΤȤ̤ɤĤ֤  */
    }

    Gcop_bmp(bmp_plm->imag_xim, &bmp_plm->drw_rect,
                        bmp_plm->canv_xim, &bmp_plm->drw_rect, NULL, mode);
                                            /*  ɽɥإԡ  */

    Gcop_bmp(bmp_plm->imag_xim, &bmp_plm->drw_rect,
                        bmp_plm->ibuf_xim, &bmp_plm->drw_rect, NULL, mode);
                              /*  ɥåǼѥӥåȥޥåפإԡ  */

    /*  ̾⡼ɡװʳΤȤ  */
    if( (mask_mode & 0x00C0) != 0x0000 )
    {
      Mask_disp(&bmp_plm->wid_rect, &bmp_plm->drw_rect, bmp_plm->canv_xim,
                                        bmp_plm->canv_csp, bmp_plm->mask_scr);
                                 /*    Фƥޥξ֤ȿǤ    */
    }

    XShmPutImage( bmp_plm->disp, bmp_plm->canv_gid, bmp_plm->canv_gc,
                             bmp_plm->canv_xim, 0, 0, 0, 0,
                             bmp_plm->wid_size.h, bmp_plm->wid_size.v, False );
                                            /*  ɥɽ  */
    return(err);
}

/*  ޥ̤ޥ꡼  */
void    Rest_mask(RECT *orgr, RECT *srcr, unsigned char *src_addr,
                    RECT *widr, RECT *dstr, unsigned char *dst_addr, int zoom)
{
  /*  orgr  srcr ΰ, widr  dstr  zoom ܤƽ񤭹  */
    int    i,j,k,l;
    int    src_addr_count = 0, dst_addr_count = 0;
    int    src_fst_addr, dst_fst_addr;
    int    src_bak_a;
    int    dst_bak_a, dst_bak_b, dst_bak_c;
    int    dst_width_count, dst_height_count;
    int    dst_width_count_a, dst_height_count_a;
    int    dst_width_count_b, dst_height_count_b;
    int    orgr_width, orgr_height, srcr_height, srcr_width;
    int    widr_height, widr_width, dstr_height, dstr_width;

    srcr_width  = srcr->c.right - srcr->c.left;
    srcr_height = srcr->c.bottom - srcr->c.top;
    orgr_width  = orgr->c.right - orgr->c.left;
    orgr_height = orgr->c.bottom - orgr->c.top;
    dstr_width  = dstr->c.right - dstr->c.left;
    dstr_height = dstr->c.bottom - dstr->c.top;
    widr_width  = widr->c.right - widr->c.left;
    widr_height = widr->c.bottom - widr->c.top;

    src_fst_addr = (srcr->c.left - orgr->c.left) +
                         (srcr->c.top - orgr->c.top) * orgr_width;

    dst_fst_addr = (dstr->c.left - widr->c.left) +
                         (dstr->c.top - widr->c.top) * widr_width;
    dst_height_count = 0;

    for(l = 0; l < srcr_height; l ++)
    {
        src_bak_a = src_addr_count;
        dst_bak_c = dst_addr_count;
	//dst_width_count = dstr->c.left;
	dst_width_count = 0;
        dst_height_count_b = dst_height_count;

        for(k = 0; k < srcr_width; k ++)
        {
            dst_bak_b = dst_addr_count;
            dst_width_count_b = dst_width_count;
            dst_height_count_a = dst_height_count_b;
            for(j = 0; j < zoom; j ++)
            {
                dst_bak_a = dst_addr_count;
                dst_width_count_a = dst_width_count_b;
                if(dst_height_count_a < dstr_height &&
                            dst_height_count_a < widr_height)
                {
                    for(i = 0; i < zoom; i ++)
                    {
                        if(dst_width_count_a < dstr_width &&
                                   dst_width_count_a < widr_width)
                        {
                            *(dst_addr + dst_addr_count + dst_fst_addr) =
                                   *(src_addr + src_fst_addr + src_addr_count);

                            dst_addr_count ++;
                            dst_width_count_a ++;
                        }
                    }
                    dst_addr_count = dst_bak_a;

                    dst_addr_count += widr_width;
                }
                dst_height_count_a ++;
            }
            dst_addr_count = dst_bak_b;
            dst_addr_count += zoom;
            src_addr_count ++;
            dst_width_count = dst_width_count_b;
            dst_width_count += zoom;
        }
        dst_addr_count = dst_bak_c;
        dst_addr_count += zoom * widr_width;
        src_addr_count = src_bak_a;
        src_addr_count += orgr_width;
        dst_height_count = dst_height_count_b;
        dst_height_count += zoom;
    }
}

/*  ޥ꡼󤫤ޥ̤  */
void    Save_mask(RECT *srcr, RECT *srdr, unsigned char *src_addr,
                     RECT *orgr, RECT *dstr, unsigned char *dst_addr, int zoom)
{
  /*  srcr  srdr ΰ orgr  dstr  zoom ̾ƽ񤭹  */
    int    i, j, k, l;
    int    src_addr_count = 0, dst_addr_count = 0;
    int    src_fst_addr, dst_fst_addr;
    int    src_bak_a, src_bak_b, src_bak_c;
    int    dst_bak_a;
    int    src_width_count, src_height_count;
    int    src_width_count_a, src_height_count_a;
    int    src_width_count_b, src_height_count_b;
    int    srcr_width, srcr_height, srdr_height, srdr_width;
    int    orgr_width, orgr_height, dstr_height, dstr_width;
    int    level, level_count;
    int    level_bak_a, level_bak_b;
    int    level_flg;

    int   org_end_adr, srcr_end_adr;

    srcr_width  = srcr->c.right - srcr->c.left;
    srcr_height = srcr->c.bottom - srcr->c.top;
    srdr_width  = srdr->c.right - srdr->c.left;
    srdr_height = srdr->c.bottom - srdr->c.top;
    dstr_width  = dstr->c.right - dstr->c.left;
    dstr_height = dstr->c.bottom - dstr->c.top;
    orgr_width  = orgr->c.right - orgr->c.left;
    orgr_height = orgr->c.bottom - orgr->c.top;

    org_end_adr = orgr_width * orgr_height;
    srcr_end_adr = srcr_width * srcr_height;

    src_fst_addr = (srdr->c.left - srcr->c.left) +
                                   (srdr->c.top - srcr->c.top) * srcr_width;

    dst_fst_addr = (dstr->c.left - orgr->c.left) +
                         (dstr->c.top - orgr->c.top) * orgr_width;

    src_height_count = srdr->c.top;

    for(l = 0; l < dstr_height; l ++)
    {
        dst_bak_a = dst_addr_count;
        src_bak_c = src_addr_count;
        src_width_count = srdr->c.left;
        src_height_count_b = src_height_count;
        for(k = 0; k < dstr_width; k ++)
        {
            src_bak_b = src_addr_count;
            src_width_count_b = src_width_count;
            src_height_count_a = src_height_count_b;
            level = 0;
            level_count = 0;
            level_bak_a = 0, level_bak_b = 0;
            level_flg = 0;

            for(j = 0; j < zoom; j ++)
            {
                src_bak_a = src_addr_count;
                src_width_count_a = src_width_count_b;
                if(src_height_count_a < srcr_height)
                {
                    for(i = 0; i < zoom; i ++)
                    {
                        if(src_width_count_a < srcr_width)
                        {
                            level +=
                                  *(src_addr + src_fst_addr + src_addr_count);

                            if(level_count == 0)
                            {
                                level_bak_a = level;
                                level_bak_b = level_bak_a;
                            }
                            else
                                if(level_bak_a != level_bak_b)
                                    level_flg = 1;

                            src_addr_count ++;
                            src_width_count_a ++;
                            level_count ++;
                        }
                    }
                    src_addr_count = src_bak_a;
                    src_addr_count += srcr_width;
                }
                src_height_count_a ++;
            }

            if(level_flg == 0)
                *(dst_addr + dst_fst_addr + dst_addr_count) = level_bak_a;
            else
                *(dst_addr + dst_fst_addr + dst_addr_count) = level / level_count;

            src_addr_count = src_bak_b;
            src_addr_count += zoom;
            dst_addr_count ++;
            src_width_count = src_width_count_b;
            src_width_count += zoom;
        }
        src_addr_count = src_bak_c;
        src_addr_count += zoom * srcr_width;

        dst_addr_count = dst_bak_a;
        dst_addr_count += orgr_width;
        src_height_count = src_height_count_b;
        src_height_count += zoom;
    }
}

/*    Фƥޥξ֤ȿǤ    */
int    Mask_disp(RECT *widr, RECT *imgr, XImage *image, Colormap cspec,
                                                  unsigned char *mask_addr)
{
  /*  ɥΰ widr ˤΰ imgr Ф,ޥξ֤ɽ롣
      gid ϥɥ GID, cspec ϥɥ CSPEC, mask_addr 
      ޥǻ٤ǼƤǡΥݥ  */

  //PIXVAL  o_pix, n_pix;
    unsigned long  o_pix, n_pix;
    COLOR   drw_col;
    COLOR   dst_col;

    unsigned char  mask_dens;    /*  ޥǻ  */
    int        i, fst_adr;
    int        wid_width, wid_height, img_width, img_height;
    int        data_len;    /*  ̤ɽƤΥǡĹ  */
    PNT        p;
    DCM        mode = G_STORE | G_CVFORM | G_CVCOLOR;  /*  ⡼  */

    DEBUG_PRINT(("Mask_disp()\n"));

    wid_width  = widr->c.right  - widr->c.left;
    wid_height = widr->c.bottom - widr->c.top;
    img_width  = imgr->c.right  - imgr->c.left;
    img_height = imgr->c.bottom - imgr->c.top;

    data_len = wid_width * wid_height;
    fst_adr = (imgr->c.left - widr->c.left) +
                                   (imgr->c.top - widr->c.top) * wid_width;

    p.x = imgr->c.left;
    p.y = imgr->c.top;

    for( i = fst_adr; i < data_len ; i ++)
    {
        if(p.y >= imgr->c.bottom)
            break;

        if(p.x < imgr->c.right)
        {
            mask_dens = *(mask_addr + i);

            if(mask_dens < 0xff)
            {
	      //gtst_pnt(gid, p, &o_pix);
              dst_col = XGetPixel(image, p.x, p.y);
                                               /*  ɽ鿧Ф  */
	      //dst_col = toRGB(o_pix, &cspec);
                                       /*  ԥͤңǣͤѴ  */

	      drw_col = Cal_color((0xff - mask_dens), dst_col, BLACK);
                                       /*  褹뿧׻ */

	      //n_pix = toPixel(drw_col, &cspec);
                                       /*  ңǣͤԥͤѴ  */
	      if(drw_col != dst_col)
                XPutPixel(image, p.x, p.y, drw_col);
	          //gdra_pnt(gid, p, n_pix, mode);
                                                /*  ɥ̤  */
            }
            p.x += 1;
        }
        else
        {
            p.y += 1;
            p.x = imgr->c.left;
            i += (wid_width - img_width - 1);
        }
    }
    return(0);
}

/*  ɥåȤĥޥ褹  */
void Put_Maskdepth(BMPPALA *bmp_plm, int dx, int dy, int adr_y,
                                                           unsigned char den)
{
    unsigned char   sub_dens;    /*  ֥饷ǻ  */
    unsigned char   mask_dens;   /*  ޥǻ  */
    unsigned char   mask_buf;    /*  ޥǻ٥Хåե  */
    PNT      p;
    //PIXVAL   o_pix, n_pix;
    COLOR   o_pix, n_pix;
    COLOR    drw_col;
    COLOR    dst_col;

    p.x = dx; p.y = dy;

    //gtst_pnt(bmpplm->ibuf_gid, p, &o_pix);
    dst_col = XGetPixel(bmp_plm->ibuf_xim, p.x, p.y);
                            /*  ɥåǼѲ鿧Ф  */
    /*  ޤƤʤʬο,ޤ褹뿧ȤǷ׻ʤƤ
      ʤʤΤ,ibuf_gid 鿧ФƤ  */

    sub_dens = *(bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y);
                                            /*  ֥饷ǻ٤Ф  */
    if ( den <= sub_dens )
        return;
    else
        *(bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y) = den;
      /*  夫֥饷ǻ٤ǻˤϡ夫ǻ٤褹  */

    mask_dens = 0xff - den;
    mask_buf = *(bmp_plm->mask_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y);
                                            /*  ޥǻ٤Ф  */

    if ( mask_dens > mask_buf )
        return;
    else
        *(bmp_plm->mask_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y)
                                                                   = mask_dens;
      /*  夫ޥǻ٤ǻˤϡ夫ǻ٤褹  */

    //dst_col = toRGB(o_pix, &bmp_plm->imag_csp);
                                       /*  ԥͤңǣͤѴ  */
    drw_col = Cal_color(den, dst_col, BLACK);
                                /*  褹뿧׻ */

    //n_pix = toPixel(drw_col, &bmp_plm->canv_csp);
                                       /*  ңǣͤԥͤѴ  */
    if(drw_col == dst_col)
        return;    /*  οȤ줫ɤ뿧Ʊ  */

    //gdra_pnt(bmp_plm->canv_gid, p, n_pix, bmp_plm->mode);
    XPutPixel(bmp_plm->canv_xim, p.x, p.y, drw_col);
                                                 /*  ɥ̤  */

    //gdra_pnt(bmp_plm->drag_gid, p, n_pix, bmp_plm->mode);
                                                 /*  ɥåѲ̤  */
}

/*  ɥåȤĥޥä  */
void Els_Maskdepth(BMPPALA *bmp_plm, int dx, int dy, int adr_y,
                                                           unsigned char den)
{
    unsigned char   sub_dens;    /*  ֥饷ǻ  */
    unsigned char   mask_dens;   /*  õΥޥǻ  */
    unsigned char   mask_buf;    /*  ޥǻ٥Хåե  */
    PNT      p;
    //PIXVAL   o_pix, n_pix;
    COLOR   o_pix, n_pix;
    COLOR    drw_col;
    COLOR    dst_col;

    p.x = dx; p.y = dy;

    //gtst_pnt(bmp_plm->ibuf_gid, p, &o_pix);
    dst_col = XGetPixel(bmp_plm->ibuf_xim, p.x, p.y);
                            /*  ɥåǼѲ鿧Ф  */
    /*  ޤƤʤʬο,ޤ褹뿧ȤǷ׻ʤƤ
      ʤʤΤ,ibuf_gid 鿧ФƤ  */

    sub_dens = *(bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y);
                                            /*  ֥饷ǻ٤Ф  */
    mask_buf = *(bmp_plm->mask_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y);
                                            /*  ޥǻ٤Ф  */

    if ( den <= sub_dens )
        return;
    else
        *(bmp_plm->brush_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y) = den;
      /*  夫֥饷ǻ٤ǻˤϡ夫ǻ٤褹  */

    mask_dens = den;     /*  õΥޥǻ٤׻  */

    if ( mask_dens < mask_buf )
        return;
    else
        *(bmp_plm->mask_scr + (dx - bmp_plm->wid_rect.c.left) + adr_y)
                                                                   = mask_dens;
      /*  夫ޥǻ٤ˤϡ夫ǻ٤褹  */

    //dst_col = toRGB(o_pix, &bmp_plm->imag_csp);
                                       /*  ԥͤңǣͤѴ  */
    drw_col = Cal_color((0xFF - mask_dens), dst_col, BLACK);
                                /*  褹뿧׻ */

    //n_pix = toPixel(drw_col, &bmp_plm->canv_csp);
                                       /*  ңǣͤԥͤѴ  */
    if(drw_col == dst_col)
        return;    /*  οȤ줫ɤ뿧Ʊ  */

    //gdra_pnt(bmp_plm->canv_gid, p, n_pix, bmp_plm->mode);
    XPutPixel(bmp_plm->canv_xim, p.x, p.y, drw_col);
                                                 /*  ɥ̤  */

    /*    gdra_pnt(bmp_plm->drag_gid, p, n_pix, bmp_plm->mode);
                                                 /*  ɥåѲ̤  */
}

/*    ޥȿž    */
void    Rev_mask(SIZE *img_size, unsigned char *mask_addr)
{
    /*  ޥǡ򣱥ɥåȤļФ,0xFF 򤽤ͤǰ(ͤȿž
        Ƥ)ޤͤɤ    */
    unsigned char  data_buf;
    int            data_len, i;

    data_len = img_size->h * img_size->v * sizeof(unsigned char);

    for(i = 0; i < data_len; i ++)
    {
        data_buf = *(mask_addr + i);  /*  ޥǡФ  */
        *(mask_addr + i) = 0xFF - data_buf;
    }
}


/*    ưޥǽ    */
void    Auto_mask(BMPPALA *bmp_plm, MSKPNL *maskpnl)
{
    /*  ǻ٤ǻˤäƥޥΥ٥ưŪꤹ  */
    /*  mag ϡǻ٤Фޥ٥Ψǻ١magޥ٥ˤʤ
        un ϡڤ夲뿧ǻ١ʿǻ٤ʲȥޥ٥ǹˤ
        ov ϡ­ڤꤹ뿧ǻ١ʿǻ٤ʾȥޥ򤫤ʤ
        ǻ٤˶Ťȥޥǻ˶ŤˤĤƥޥ
        Ƥ롣
        ܤοǻ٤Υ顼ͤȤϵդˤʤΤա
                                          
             顼͡    (255)<-------------->(0)
    */

    unsigned char  mask_dens = 0;   /*  ޥǻ  */
    unsigned char  src[3];
    unsigned long  src_msk;
    int     i;
    int     left, right, top, bottom, width, adr_y;
    PNT      p;     /*  򻲾Ȥ븶ΰ  */
    //PIXVAL   pix;   /*  ԥ  */
    COLOR    col;   /*  顼  */

    left   = bmp_plm->org_bmp.bounds.c.left;
    right  = bmp_plm->org_bmp.bounds.c.right;
    top    = bmp_plm->org_bmp.bounds.c.top;
    bottom = bmp_plm->org_bmp.bounds.c.top + bmp_plm->org_size.v;
    width = right - left;

    //gset_ptr(PS_BUSY, NULL, -1, -1);    /*  ݥ󥿤ߤˤ  */

    for(p.y = top; p.y < bottom; p.y ++)
    {
        adr_y = (p.y - top) * width;    /*  ֥饷ǻ٤λȰ  */

        for(p.x = left; p.x < right; p.x ++)
	{
            col = XGetPixel(bmp_plm->org_xim, p.x, p.y);
            //gtst_pnt(bmp_plm->org_gid, p, &pix);
                                            /*  鿧Ф  */

            //col = toRGB(pix, &bmp_plm->imag_csp);
                                       /*  ԥͤңǣͤѴ  */

            src_msk = 0;
            for(i = 0; i < 3; i++)
            {
                 src[i] = (col >> ((2-i) * 8)) & 0xFF;
	                                 	 /*  ңǣͤʬΥ  */
                 src_msk += src[i];
            }
            src_msk = src_msk / 3;
            if(src_msk < maskpnl->un)
	        src_msk = 0;
	    if(src_msk > maskpnl->ov)
	        src_msk = 0xFF;

            src_msk = 0xFF - src_msk;
            src_msk *= maskpnl->mag;   /*  ǻ١ܿ  */

            if(src_msk > 255)
                src_msk = 255;

            mask_dens = 0xFF - src_msk;

            *(bmp_plm->mask_mat + (p.x - left) + adr_y) = mask_dens;
                                                /*  ޥǻ٤  */
	}
    }
}
