/*
	menu.c		xbrush

	˥塼ɽȥ٥
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;       /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern Widget top;
extern char   *funcexp[];   /*  ֥饷δؿ  */

static Widget  edit_mid, paint_st, sel_bounds, line1, clear_canv;
                                                       /*  Խ˥塼  */
static Widget  ordinary, reflect, drawmsk, erasemsk;
static Widget  line2, domsk, turnmsk, automsk;   /*  ޥ˥塼  */
static Widget  insti_mid, size_mid, dens_mid, line_tab, tab_mid;
                                                    /*  ˥塼  */

/*  ؿ˥塼  */
void Popup_funcmenu(XEvent *wevnt, PRGID *prg_id,
                    BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  int  mn;           /*  ֹ  */
  int  fno;          /*  򤷤ؿֹ  */
    //WDSTAT  stat;    /*  ɥ  */
  PNT     gpos;    /*  кɸ  */
  RECT rect;
  Arg  args[2];
  char  label[4];
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;

  XQueryPointer(bmp_plm->disp, bmp_plm->cons_gid, &root, &child, &rx, &ry,
  		    &wx, &wy, &mask);   /*  ޥݥ󥿤ΰ  */

  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)wx);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)wy);

  XtSetValues( prg_id->func_mid, args, XtNumber(args) );
                                              /*  ٥륦åȤ  */

  XtManageChild( prg_id->func_mid );  /*  åȤɽ  */
}

/*  ؿ  */
void Sel_funcmenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  consparts->funcval.func_no = (int)client_data;  /*  ؿֹ */
  Draw_func(bmpplm->cons_gc, consparts);  /*  ؿɽ  */
  if( XtIsRealized(prgid->func_mid) )
    XtUnmanageChild( prgid->func_mid );  /*  ؿ˥塼Ĥ  */
}

/*  ᥤ˥塼  */
void Sel_mainmenu(Widget w, PRGID *prg_id, BMPPALA *bmp_plm,
                                                   CONSPATS *cons_parts)
{

    if( w == clear_canv )  /*  ɲ̥ꥢɤξ  */
    {
      Cls_gid(bmp_plm); /*  ̥ꥢ  */

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == ordinary )       /*  ̾ξ  */
    {
      prg_id->mask_mode &= 0xFF3F;

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == reflect )        /*  ޥȿξ  */
    {
      prg_id->mask_mode &= 0xFF3F;
      prg_id->mask_mode |= 0x0040;

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == drawmsk )        /*  ޥξ  */
    {
      prg_id->mask_mode &= 0xFF3F;
      prg_id->mask_mode |= 0x0080;

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == erasemsk )       /*  ޥõξ  */
    {
      prg_id->mask_mode &= 0xFF3F;
      prg_id->mask_mode |= 0x00C0;

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == domsk )       /*  ޥΤɽξ  */
    {
      if(prg_id->mask_mode & 0x0020)
        prg_id->mask_mode &= 0xFFDF;
      else
        prg_id->mask_mode |= 0x0020;

      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == turnmsk )      /*  ޥȿžξ  */
    {
      Rev_mask(&bmp_plm->org_size, bmp_plm->mask_mat);
                                                           /*  ޥȿž  */
      prg_id->mask_mode |= 0x0001;   /*  ˥ޥ褷  */
      prg_id->xb_mode |= 0x0008;   /*  褷  */

      Rest_mask(&bmp_plm->org_bmp.bounds, &bmp_plm->zoom_rect,
                          bmp_plm->mask_mat,
                         &bmp_plm->wid_rect,  &bmp_plm->drw_rect,
                                            bmp_plm->mask_scr, bmp_plm->zoom);
                                    /*  ޥ̤ޥ꡼  */
      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == automsk )      /*  ưޥξ  */
    {
      if( XtIsRealized(prg_id->main_mid) )
        XtUnmanageChild( prg_id->main_mid );  /*  ᥤ˥塼Ĥ  */

      XtManageChild( prg_id->automsk.main_pnl );  /*  åȤɽ  */
      if( Automask_pnl(cons_parts) ) /*    ưޥѥͥ    */
      {
        //Auto_mask(bmpplm, &cons_parts->maskpnl);
                                               /*  ưޥǽ  */
        prg_id->mask_mode |= 0x0001;   /*  ˥ޥ褷  */
        prg_id->xb_mode |= 0x0008;   /*  褷  */
      }
      Rest_mask(&bmp_plm->org_bmp.bounds, &bmp_plm->zoom_rect,
                          bmp_plm->mask_mat,
                         &bmp_plm->wid_rect,  &bmp_plm->drw_rect,
                                            bmp_plm->mask_scr, bmp_plm->zoom);
                                    /*  ޥ̤ޥ꡼  */
      Redraw_canv(prg_id, bmp_plm);   /*  襦ɥκɽ  */
    }
    else if( w == size_mid )       /*  ξ  */
    {
      if( prg_id->xb_mode & 0x0080 )
        prg_id->xb_mode &= 0xFF7F;
      else
        prg_id->xb_mode |= 0x0080;
    }
    else if( w == dens_mid )       /*  ǻٴξ  */
    {
      if( prg_id->xb_mode & 0x0040 )
        prg_id->xb_mode &= 0xFFBF;
      else
        prg_id->xb_mode |= 0x0040;
    }

    else if( w == tab_mid )       /*  ֥åξ  */
    {
      if( XtIsRealized(prg_id->main_mid) )
        XtUnmanageChild( prg_id->main_mid );  /*  ᥤ˥塼Ĥ  */
      XtManageChild( prg_id->tabpnl.main_pnl );  /*  åȤɽ  */
      Tabletto_pnl(cons_parts, prg_id);  /*  ֥åΥݥåץå  */
    }

    Popdown_mainmenu(prg_id->main_mid, NULL, NULL);
                                /*  ᥤ˥塼Υݥåץ  */
}

/*  ˥塼ΥХå  */
void Menu_callback(Widget w, caddr_t client_data, caddr_t call_data)
{
  Sel_mainmenu(w, prgid, bmpplm, consparts);
                                                   /*  ᥤ˥塼  */
}

/*  ᥤ˥塼Υݥåץ  */
void Popdown_mainmenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  if( XtIsRealized(prgid->main_mid) )
    XtUnmanageChild( prgid->main_mid );  /*  ᥤ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.edit_mid) )
    XtUnmanageChild( prgid->menusel.edit_mid );  /*  Խ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.mask_mid) )
    XtUnmanageChild( prgid->menusel.mask_mid );  /*  ޥ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.inst_mid) )
    XtUnmanageChild( prgid->menusel.inst_mid );  /*  ˥塼Ĥ  */
}

/*  ֥˥塼Υݥåץ  */
void Popdown_submenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  if( XtIsRealized(prgid->menusel.edit_mid) )
    XtUnmanageChild( prgid->menusel.edit_mid );  /*  Խ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.mask_mid) )
    XtUnmanageChild( prgid->menusel.mask_mid );  /*  ޥ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.inst_mid) )
    XtUnmanageChild( prgid->menusel.inst_mid );  /*  ˥塼Ĥ  */
}

/*  ᥤ˥塼Υݥåץå  */
void Popup_mainmenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  XtManageChild( prgid->main_mid );  /*  åȤɽ  */
}

/*  Խ˥塼Υݥåץå  */
void Popup_editmenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  Arg  args[2], args_s[2], args_n[2];
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;

  XQueryPointer(bmpplm->disp, bmpplm->cons_gid, &root, &child, &rx, &ry,
  		    &wx, &wy, &mask);   /*  ޥݥ󥿤ΰ  */

  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)wx);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)wy);

  XtSetValues( prgid->menusel.edit_mid, args, XtNumber(args) );
                                              /*  ܥååȤ  */

  XtSetArg( args_s[0], XtNforeground, (XtArgVal)prgid->menusel.back);
  XtSetArg( args_s[1], XtNbackground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[0], XtNforeground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[1], XtNbackground, (XtArgVal)prgid->menusel.back);

  if((prgid->xb_mode & 0x0001) == 0x0001)         /*  ⡼  */
  {
    XtSetValues( paint_st, args_s, XtNumber(args_s) );
                                              /*  åȤ  */
  }
  else         /*  ΰ⡼  */
  {
    XtSetValues( paint_st, args_n, XtNumber(args_n) );
                                              /*  åȤ  */
  }

  if( XtIsRealized(prgid->menusel.mask_mid) )
    XtUnmanageChild( prgid->menusel.mask_mid );  /*  ޥ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.inst_mid) )
    XtUnmanageChild( prgid->menusel.inst_mid );  /*  ˥塼Ĥ  */

  XtManageChild( prgid->menusel.edit_mid );  /*  Խ˥塼ɽ  */
}


/*  ޥ˥塼Υݥåץå  */
void Popup_maskmenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  Arg  args[2], args_s[2], args_n[2];
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;

  XQueryPointer(bmpplm->disp, bmpplm->cons_gid, &root, &child, &rx, &ry,
  		    &wx, &wy, &mask);   /*  ޥݥ󥿤ΰ  */

  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)wx);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)wy);

  XtSetValues( prgid->menusel.mask_mid, args, XtNumber(args) );
                                              /*  ٥륦åȤ  */

  XtSetArg( args_s[0], XtNforeground, (XtArgVal)prgid->menusel.back);
  XtSetArg( args_s[1], XtNbackground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[0], XtNforeground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[1], XtNbackground, (XtArgVal)prgid->menusel.back);

  XtSetValues( ordinary, args_n, XtNumber(args_n) );  /*  ̾  */
  XtSetValues( reflect, args_n, XtNumber(args_n) );  /*  ȿ  */
  XtSetValues( drawmsk, args_n, XtNumber(args_n) );  /*  ޥ  */
  XtSetValues( erasemsk, args_n, XtNumber(args_n) );  /*  ޥõ  */

  if((prgid->mask_mode & 0x00F0) == 0x0000)    /*  ̾⡼  */
    XtSetValues( ordinary, args_s, XtNumber(args_s) );  /*  ̾  */

  else if((prgid->mask_mode & 0x00C0) == 0x0040)  /*  ޥȿ⡼  */
    XtSetValues( reflect, args_s, XtNumber(args_s) );  /*  ȿ  */

  else if((prgid->mask_mode & 0x00C0) == 0x0080)  /*  ޥ⡼  */
    XtSetValues( drawmsk, args_s, XtNumber(args_s) );  /*  ޥ  */

  else if((prgid->mask_mode & 0x00C0) == 0x00C0)  /*  ޥõ⡼  */
    XtSetValues( erasemsk, args_s, XtNumber(args_s) );  /*  ޥõ  */

  if((prgid->mask_mode & 0x0020) == 0x0020)    /*  ޥΤɽ⡼  */
  {
    XtSetValues( domsk, args_s, XtNumber(args_s) ); /*  ޥΤɽ  */
  }
  else 
  {
    XtSetValues( domsk, args_n, XtNumber(args_n) ); /*  ޥΤɽ  */
  }

  if( XtIsRealized(prgid->menusel.edit_mid) )
    XtUnmanageChild( prgid->menusel.edit_mid );  /*  Խ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.inst_mid) )
    XtUnmanageChild( prgid->menusel.inst_mid );  /*  ˥塼Ĥ  */

  XtManageChild( prgid->menusel.mask_mid );  /*  åȤɽ  */
}

/*  ˥塼Υݥåץå  */
void Popup_instimenu(Widget w, caddr_t client_data, caddr_t call_data)
{
  Arg  args[2], args_s[2], args_n[2];
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;

  XQueryPointer(bmpplm->disp, bmpplm->cons_gid, &root, &child, &rx, &ry,
  		    &wx, &wy, &mask);   /*  ޥݥ󥿤ΰ  */

  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)wx);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)wy);

  XtSetValues( prgid->menusel.inst_mid, args, XtNumber(args) );
                                              /*  ܥååȤ  */

  XtSetArg( args_s[0], XtNforeground, (XtArgVal)prgid->menusel.back);
  XtSetArg( args_s[1], XtNbackground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[0], XtNforeground, (XtArgVal)prgid->menusel.fore);
  XtSetArg( args_n[1], XtNbackground, (XtArgVal)prgid->menusel.back);

  if((prgid->xb_mode & 0x0080) == 0x0080)         /*    */
  {
    XtSetValues( size_mid, args_s, XtNumber(args_s) );
                                              /*  åȤ  */
  }
  else
  {
    XtSetValues( size_mid, args_n, XtNumber(args_n) );
                                              /*  åȤ  */
  }

  if((prgid->xb_mode & 0x0040) == 0x0040)         /*  ǻٴ  */
  {
    XtSetValues( dens_mid, args_s, XtNumber(args_s) );
                                              /*  åȤ  */
  }
  else
  {
    XtSetValues( dens_mid, args_n, XtNumber(args_n) );
                                              /*  åȤ  */
  }

  if( XtIsRealized(prgid->menusel.edit_mid) )
    XtUnmanageChild( prgid->menusel.edit_mid );  /*  Խ˥塼Ĥ  */
  if( XtIsRealized(prgid->menusel.mask_mid) )
    XtUnmanageChild( prgid->menusel.mask_mid );  /*  ޥ˥塼Ĥ  */

  XtManageChild( prgid->menusel.inst_mid );  /*  åȤɽ  */
}

Widget Editmenu(PRGID *prg_id)  /*  Խ˥塼κ  */
{
  XFontStruct *fnt;    /*  Font Struct */

  static XtActionsRec actionTable[] =
    { {"Popdownmainmenu", (XtActionProc)Popdown_mainmenu}, };

  static  char  defaultTranslations[] =
    "<LeaveWindow> : Popdown_mainmenu()";

  static  char  defaultTranslations2[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";

  XtTranslations trans_table, trans_table2;

  fnt = XLoadQueryFont( XtDisplay( prg_id->cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  edit_mid = XtVaCreateWidget("Edit_popup", boxWidgetClass,
                                     prg_id->pwid,
				     XtNwidth,  120,
				     XtNheight, 56,
				     XtNhSpace, 0,
				     XtNvSpace, 0,
 				     XtNbackground,  LGRAY,
 				     NULL);

  paint_st  = XtVaCreateManagedWidget("paint", commandWidgetClass,
                                  edit_mid,
			          XtNlabel, (XtArgVal)"Paint state",
				  XtNborderWidth,  0,
				  XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,  LGRAY,
				  NULL);

  sel_bounds  = XtVaCreateManagedWidget("select", commandWidgetClass,
                                  edit_mid,
			          XtNlabel, (XtArgVal)"Select Bounds",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
				  XtNsensitive,     False,
 				  XtNbackground,  LGRAY,
				  NULL);

  line1 =  XtVaCreateManagedWidget("Line", commandWidgetClass,
				     edit_mid,
				     XtNborderWidth,   2,
				     XtNwidth,         120,
				     XtNheight,        1,
			             XtNlabel, (XtArgVal)"",
				     XtNsensitive,     False,
 				     XtNbackground,  LGRAY,
                                     NULL);

  clear_canv  = XtVaCreateManagedWidget("clear", commandWidgetClass,
                                  edit_mid,
			          XtNlabel, (XtArgVal)"Clear Canvus",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,  LGRAY,
				  NULL);

  XtAddActions(actionTable, XtNumber(actionTable));
                                               /*  ơ֥Ͽ  */
  trans_table = XtParseTranslationTable(defaultTranslations);
  trans_table2 = XtParseTranslationTable(defaultTranslations2);
                                      /*  ȥ󥹥졼ơ֥Ͽ  */
  XtOverrideTranslations(edit_mid, trans_table);
  XtOverrideTranslations(paint_st, trans_table2);
  XtOverrideTranslations(clear_canv, trans_table2);

  XtAddCallback(clear_canv, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
                                    /*  ɲ̥ꥢɤΥХåϿ  */
  return(edit_mid);
}

Widget Maskmenu(PRGID *prg_id)  /*  ޥ˥塼  */
{
  static Widget  mask_mid;
  XFontStruct *fnt;    /*  Font Struct */

  static  char  defaultTranslations[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";
  XtTranslations trans_table;

  fnt = XLoadQueryFont( XtDisplay( prg_id->cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  mask_mid = XtVaCreateWidget("Mask_popup", boxWidgetClass,
                                    prg_id->pwid,
				     XtNwidth,  120,
				     XtNheight, 124,
				     XtNhSpace, 0,
				     XtNvSpace, 0,
				     //XtNhorizDistance, 1,
				     //XtNvertDistance, 1,
 				     XtNbackground,  LGRAY,
				    NULL);

  ordinary  = XtVaCreateManagedWidget("ordinary", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Ordinary Paint",
				  XtNborderWidth,  0,
				  XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  reflect  = XtVaCreateManagedWidget("reflect", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Reflect Paint",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  drawmsk  = XtVaCreateManagedWidget("drawmsk", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Draw Mask",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  erasemsk  = XtVaCreateManagedWidget("erasemsk", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Erase Mask",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  line2 =  XtVaCreateManagedWidget("Line2", commandWidgetClass,
				     mask_mid,
				     XtNborderWidth,   2,
				     XtNwidth,         120,
				     XtNheight,        1,
			             XtNlabel, (XtArgVal)"",
				     XtNsensitive,     False,
 				     XtNbackground,    LGRAY,
                                     NULL);

  domsk  = XtVaCreateManagedWidget("domsk", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Disp only Mask",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  turnmsk  = XtVaCreateManagedWidget("turnmsk", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Turn Mask",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  automsk  = XtVaCreateManagedWidget("automsk", commandWidgetClass,
                                  mask_mid,
			          XtNlabel, (XtArgVal)"Auto Mask",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(ordinary, trans_table);
  XtOverrideTranslations(reflect, trans_table);
  XtOverrideTranslations(drawmsk, trans_table);
  XtOverrideTranslations(erasemsk, trans_table);
  XtOverrideTranslations(domsk, trans_table);
  XtOverrideTranslations(turnmsk, trans_table);
  XtOverrideTranslations(automsk, trans_table);
                                               /*  ȥ󥹥졼Ͽ  */

  XtAddCallback(ordinary, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(reflect, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(drawmsk, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(erasemsk, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(domsk, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(turnmsk, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(automsk, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
                                               /*  ХåϿ  */
  return(mask_mid);
}

Widget Instimenu(PRGID *prg_id)  /*  ˥塼κ  */
{
  XFontStruct *fnt;    /*  Font Struct */

  static XtActionsRec actionTable[] =
    { {"Popdownmainmenu", (XtActionProc)Popdown_mainmenu}, };

  static  char  defaultTranslations[] =
    "<LeaveWindow> : Popdown_mainmenu()";

  static  char  defaultTranslations2[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";

  XtTranslations trans_table, trans_table2;

  fnt = XLoadQueryFont( XtDisplay( prg_id->cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  insti_mid = XtVaCreateWidget("Insti_popup", boxWidgetClass,
                                     prg_id->pwid,
				     XtNwidth,  120,
				     XtNheight, 56,
				     XtNhSpace, 0,
				     XtNvSpace, 0,
 				     XtNbackground,  LGRAY,
 				     NULL);

  size_mid  = XtVaCreateManagedWidget("size", commandWidgetClass,
                                  insti_mid,
			          XtNlabel, (XtArgVal)"Size base",
				  XtNborderWidth,  0,
				  XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  dens_mid  = XtVaCreateManagedWidget("dens", commandWidgetClass,
                                  insti_mid,
			          XtNlabel, (XtArgVal)"Dens base",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);

  line_tab =  XtVaCreateManagedWidget("Line", commandWidgetClass,
				     insti_mid,
				     XtNborderWidth,   2,
				     XtNwidth,         120,
				     XtNheight,        1,
			             XtNlabel, (XtArgVal)"",
				     XtNsensitive,     False,
 				     XtNbackground,    LGRAY,
                                     NULL);

  tab_mid  = XtVaCreateManagedWidget("tab", commandWidgetClass,
                                  insti_mid,
			          XtNlabel, (XtArgVal)"Tabletto parameter",
				  XtNborderWidth,  0,
			          XtNwidth,        120,
			          XtNheight,       17,
				  XtNfont,         fnt,
 				  XtNbackground,   LGRAY,
				  NULL);


  XtAddActions(actionTable, XtNumber(actionTable));
                                               /*  ơ֥Ͽ  */
  trans_table = XtParseTranslationTable(defaultTranslations);
  trans_table2 = XtParseTranslationTable(defaultTranslations2);
                                      /*  ȥ󥹥졼ơ֥Ͽ  */
  XtOverrideTranslations(insti_mid, trans_table);
  XtOverrideTranslations(size_mid, trans_table2);
  XtOverrideTranslations(dens_mid, trans_table2);
  XtOverrideTranslations(tab_mid, trans_table2);

  XtAddCallback(size_mid, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(dens_mid, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
  XtAddCallback(tab_mid, XtNcallback, (XtCallbackProc)Menu_callback, NULL);
                                                     /*  ХåϿ  */
  return(insti_mid);
}

Widget Mainmenu(PRGID *prg_id)  /*  ᥤ˥塼κ  */
{
  static Widget  Menu, mpopup, filesel, edit, mask, inst, quit, line;
  XFontStruct *fnt;    /*  Font Struct */

  static XtActionsRec actionTable[] =
    { {"Popupmaskmenu",   (XtActionProc)Popup_maskmenu},
      {"Popupeditmenu",   (XtActionProc)Popup_editmenu},
      {"Popupinstimenu",  (XtActionProc)Popup_instimenu},
      {"Popdownmainmenu", (XtActionProc)Popdown_mainmenu},
      {"Popdownsubmenu",  (XtActionProc)Popdown_submenu}, }; 
                                /*  ơ֥  */

  static  char  defaultTranslations[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";      /*  ȥ󥹥졼ơ֥  */

  static  char  defaultTranslations2[] =
    "<BtnUp> : Popdownmainmenu()";

  static  char  defaultTranslations3[] =
    "<EnterWindow> : highlight()Popupeditmenu() \n\
     <LeaveWindow> : reset()";

  static  char  defaultTranslations4[] =
    "<EnterWindow> : highlight()Popupmaskmenu() \n\
     <LeaveWindow> : reset()";

  static  char  defaultTranslations5[] =
    "<EnterWindow> : highlight()Popupinstimenu() \n\
     <LeaveWindow> : reset()";

  static  char  defaultTranslations6[] =
    "<EnterWindow> : highlight()Popdownsubmenu() \n\
     <LeaveWindow> : reset()";

  XtTranslations trans_table, trans_table2, trans_table3,
                 trans_table4, trans_table5, trans_table6;

  fnt = XLoadQueryFont( XtDisplay( prg_id->cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  Menu   = XtVaCreateManagedWidget("Menu", commandWidgetClass,
				   prg_id->cons_wid,
				   XtNhorizDistance,  4,
			           XtNvertDistance,   56,
				   XtNwidth,          100,
				   XtNheight,         20,
			           XtNtop,    XtChainTop,
			           XtNbottom, XtChainTop,
			           XtNfont,           fnt,
				   XtNbackground,  LGRAY,
			           NULL);

  mpopup = XtVaCreateWidget("Menu_popup", boxWidgetClass,
				     prg_id->cons_wid,
				     XtNwidth,            100,
				     XtNheight,           90,
				     XtNhSpace,           0,
				     XtNvSpace,           0,
				     //XtNhorizDistance,  1,
				     //XtNvertDistance,   1,
			             XtNhorizDistance,    4,
			             XtNvertDistance,     76,
				   //XtNmappedWhenManaged,   False,
				     XtNbackground,  LGRAY,
                                     NULL);

  filesel  = XtVaCreateManagedWidget("Filesel", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   0,
				     XtNwidth,         100,
				     XtNheight,        17,
			             XtNfont,          fnt,
				     XtNbackground,  LGRAY,
                                     NULL);

  edit  = XtVaCreateManagedWidget("Edit", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   0,
				     XtNwidth,         100,
				     XtNheight,        17,
			             XtNfont,          fnt,
				     XtNbackground,  LGRAY,
                                     NULL);

  mask  = XtVaCreateManagedWidget("Mask", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   0,
				     XtNwidth,         100,
				     XtNheight,        17,
			             XtNfont,          fnt,
				     XtNbackground,  LGRAY,
                                     NULL);

  inst  = XtVaCreateManagedWidget("Institute", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   0,
				     XtNwidth,         100,
				     XtNheight,        17,
			             XtNfont,          fnt,
				     XtNbackground,  LGRAY,
                                     NULL);

  line =  XtVaCreateManagedWidget("Line", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   2,
				     XtNwidth,         100,
				     XtNheight,        1,
			             XtNlabel, (XtArgVal)"",
				     XtNsensitive,     False,
				     XtNbackground,  LGRAY,
                                     NULL);

  quit  = XtVaCreateManagedWidget("Quit", commandWidgetClass,
				     mpopup,
				     XtNborderWidth,   0,
				     XtNwidth,         100,
				     XtNheight,        17,
			             XtNfont,          fnt,
				     XtNbackground,  LGRAY,
                                     NULL);

  XtAddActions(actionTable, XtNumber(actionTable));
                                               /*  ơ֥Ͽ  */
  trans_table = XtParseTranslationTable(defaultTranslations);
  trans_table2 = XtParseTranslationTable(defaultTranslations2);
  trans_table3 = XtParseTranslationTable(defaultTranslations3);
  trans_table4 = XtParseTranslationTable(defaultTranslations4);
  trans_table5 = XtParseTranslationTable(defaultTranslations5);
  trans_table6 = XtParseTranslationTable(defaultTranslations6);
                                      /*  ȥ󥹥졼ơ֥Ͽ  */

  XtOverrideTranslations(Menu, trans_table);
  XtOverrideTranslations(mpopup, trans_table2);
  XtOverrideTranslations(filesel, trans_table6);
  XtOverrideTranslations(edit, trans_table3);
  XtOverrideTranslations(mask, trans_table4);
  XtOverrideTranslations(inst, trans_table5);
  XtOverrideTranslations(quit, trans_table6);

  XtAddCallback(Menu, XtNcallback, (XtCallbackProc)Popup_mainmenu, NULL);
  XtAddCallback(filesel, XtNcallback, (XtCallbackProc)Popup_filesel, NULL);
  XtAddCallback(quit, XtNcallback, (XtCallbackProc)Exit, NULL);

  return(mpopup);
}

Widget Funcmenu(PRGID *prg_id)  /*  ؿ˥塼κ  */
{
  static Widget  main_box, func_w[4];
  XFontStruct *fnt;    /*  Font Struct */
  int i;

  static  char  defaultTranslations[] =
    "<EnterWindow> : highlight() \n\
     <LeaveWindow> : reset()";
  XtTranslations trans_table;

  fnt = XLoadQueryFont( XtDisplay( prg_id->cons_wid ), "-*-bold-*--13-*" );
                                                 /*  եȤΥ  */

  main_box  = XtVaCreateWidget("Brush_popup", boxWidgetClass,
                                      prg_id->pwid,
				     //prgid->cons_wid,
				     XtNwidth, 80,
				     XtNheight, 68,
				     XtNhSpace, 0,
				     XtNvSpace, 0,
 				     XtNbackground,  LGRAY,
                                     NULL);

  trans_table = XtParseTranslationTable(defaultTranslations);
  for(i = 0 ; i < 4 ; i++)
  {
    func_w[i] = XtVaCreateManagedWidget(funcexp[i], commandWidgetClass,
					main_box,
				        XtNborderWidth,  0,
				        XtNwidth,        80,
				        XtNheight,       17,
					XtNfont,         fnt,
 				        XtNbackground,   LGRAY,
				        NULL);
    XtOverrideTranslations(func_w[i], trans_table);
  };

  XtAddCallback(func_w[0], XtNcallback,
                                   (XtCallbackProc)Sel_funcmenu, (caddr_t)0);
  XtAddCallback(func_w[1], XtNcallback,
                                   (XtCallbackProc)Sel_funcmenu, (caddr_t)1);
  XtAddCallback(func_w[2], XtNcallback,
                                   (XtCallbackProc)Sel_funcmenu, (caddr_t)2);
  XtAddCallback(func_w[3], XtNcallback,
                                   (XtCallbackProc)Sel_funcmenu, (caddr_t)3);

  return(main_box);
}

/*  ˥塼Ͽ  */
Widget Set_menu(PRGID *prg_id, BMPPALA *bmp_plm)
{
  Arg  args_color[2];
  Dimension  fore, back;

  prg_id->menusel.fore = BLACK;
  prg_id->menusel.back = GRAY;
                      /*  ե饦ɤȥХå饦ɤο  */

  prg_id->main_mid = Mainmenu(prg_id);  /*  ᥤ˥塼κ  */
  prg_id->filesel.box = Filemenu(prg_id);  /*  ե˥塼κ  */
  prg_id->automsk.main_pnl = Automaskmenu(consparts, prg_id);
                                              /* ȥޥѥͥκ  */
  prg_id->tabpnl.main_pnl = Tablettomenu(consparts, prg_id);
                                              /* ֥åѥͥκ  */
  prg_id->menusel.edit_mid = Editmenu(prg_id);  /*  Խ˥塼κ  */
  prg_id->menusel.mask_mid = Maskmenu(prg_id);  /*  ޥ˥塼κ  */
  prg_id->menusel.inst_mid = Instimenu(prg_id);  /*  ˥塼κ  */

  prg_id->func_mid = Funcmenu(prg_id);  /*  ؿ˥塼κ  */
  return(prg_id->main_mid);
}
