/*
	panel.c		xbrush

	ѥͥɽ
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/AsciiText.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern XFontStruct *info;    /*  Font Struct */

static Widget  automask_box, amsk_mag, range_min;
static Widget  range_max, amsk_cancel, amsk_ok;

static char defaultTranslations[] = "<Key>Return: no-op()";

char   *amsk_label[] = {(char[]){"AUTO MASK"},
                       (char[]){"Mask strength:"},
                       (char[]){"times"},
                       (char[]){"Thresh hold"},
                       (char[]){"Range"},
                       (char[]){"MIN:"},
                       (char[]){"MAX:"},
                      };   /*  ưޥѥͥΥ٥  */


/*  ưޥѥͥ 󥻥륳Хå  */
void Amsk_cancel(Widget w, caddr_t client_data, caddr_t call_data)
{
  XtUnmanageChild( automask_box );  /*  ѥͥĤ  */
}

/*  ưޥѥͥ ¹ԥХå  */
void Amsk_ok(Widget w, caddr_t client_data, caddr_t call_data)
{
  String value;

  XtVaGetValues( amsk_mag, XtNstring, &value, NULL );
  consparts->maskpnl.mag = atof(value);  /*  "Ψ"ͤμФ  */
  if(consparts->maskpnl.mag > 255)
  {    /*  ޥ٥Ͽǻ٤255ܤޤ  */
    consparts->maskpnl.mag = 255;
  }
  XtVaGetValues( range_min, XtNstring, &value, NULL );
  consparts->maskpnl.ov = atoi(value);  /*  ""ͤμФ  */
  if(consparts->maskpnl.ov > 255)
  {    /*  ­ڤꤹ뿧ǻ٤ 255 ޤ  */
    consparts->maskpnl.ov = 255;
  }
  XtVaGetValues( range_max, XtNstring, &value, NULL );
  consparts->maskpnl.un = atoi(value);  /*  ""ͤμФ  */
  if(consparts->maskpnl.un > 255)
  {     /*  ڤ夲뿧ǻ٤ 255 ޤ  */
    consparts->maskpnl.un = 255;
  }

  Auto_mask(bmpplm, &consparts->maskpnl);  /*    ưޥǽ    */
  XtUnmanageChild( automask_box );  /*  ѥͥĤ  */
  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect,
                          bmpplm->mask_mat,
                         &bmpplm->wid_rect,  &bmpplm->drw_rect,
                                            bmpplm->mask_scr, bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */
  Redraw_canv(prgid, bmpplm);  /*  襦ɥκɽ  */
}

/*  ưޥѥͥν  */
void Init_maskpnl(MSKPNL *maskpnl)
{
    /*  mag ϡǻ٤Фޥ٥Ψǻ١magޥ٥ˤʤ
        un ϡڤ夲뿧ǻ١ʿǻ٤ʲȥޥ٥ǹˤ
        ov ϡ­ڤꤹ뿧ǻ١ʿǻ٤ʾȥޥ򤫤ʤ    */
    maskpnl->mag = 2;
    maskpnl->un = 0;
    maskpnl->ov = 255;
}

/*    ưޥѥͥ    */
Widget  Automaskmenu(CONSPATS *cons_parts, PRGID *prg_id)
{
  int horiz, vert;
  RECT rect;

  XtTranslations trans_table;

  Wget_wrk(prg_id->pwid, &rect);  /*  ɥɽΰΰ  */

  horiz = ((rect.c.right - rect.c.left) - 200) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 150) / 2;

  automask_box = XtVaCreateWidget("automaskbox", formWidgetClass,
                            prg_id->pwid,
			    XtNborderWidth, 4,
			    XtNwidth, 200,
			    XtNheight, 150,
			    XtNhorizDistance, (XtArgVal)horiz,
			    XtNvertDistance,  (XtArgVal)vert,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNleft,   XtChainLeft,
			    XtNright,  XtChainLeft,
 			    XtNbackground,  GRAY,
			    NULL);

  amsk_mag = XtVaCreateManagedWidget("magn",
                                     asciiTextWidgetClass,
                                     automask_box,
			             XtNhorizDistance, 125,
			             XtNvertDistance,  40,
				     XtNlength, 4,
				     XtNwidth,  35,
				     XtNheight, 20,
				     XtNeditType, XawtextEdit,
				     XtNfont,   info,
 				     XtNbackground,  LGRAY,
				     NULL);

  range_min = XtVaCreateManagedWidget("range_min",
                                     asciiTextWidgetClass,
                                     automask_box,
			             XtNhorizDistance, 80,
			             XtNvertDistance,  90,
				     XtNlength, 3,
				     XtNwidth,  30,
				     XtNheight, 20,
				     XtNeditType, XawtextEdit,
				     XtNfont,   info,
 				     XtNbackground,  LGRAY,
				     NULL);

  range_max = XtVaCreateManagedWidget("range_max",
                                     asciiTextWidgetClass,
                                     automask_box,
			             XtNhorizDistance, 160,
			             XtNvertDistance,  90,
				     XtNlength, 3,
				     XtNwidth,  30,
				     XtNheight, 20,
				     XtNeditType, XawtextEdit,
				     XtNfont,   info,
 				     XtNbackground,  LGRAY,
				     NULL);

  amsk_cancel  = XtVaCreateManagedWidget("Cancel", commandWidgetClass,
                                     automask_box,
 			             XtNlabel, (XtArgVal)"Cancel",
			             XtNhorizDistance, 30,
			             XtNvertDistance,  120,
				     XtNwidth,  46,
				     XtNheight, 20,
				     XtNfont,   info,
 				     XtNbackground,  LGRAY,
				     NULL);

  amsk_ok  = XtVaCreateManagedWidget("ok", commandWidgetClass,
                                     automask_box,
 			             XtNlabel, (XtArgVal)"O  K",
			             XtNhorizDistance, 130,
			             XtNvertDistance,  120,
				     XtNwidth,  40,
				     XtNheight, 20,
				     XtNfont,   info,
 				     XtNbackground,  LGRAY,
				     NULL);

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(amsk_mag, trans_table);
  XtOverrideTranslations(range_min, trans_table);
  XtOverrideTranslations(range_max, trans_table);
                                      /*  ȥ󥹥졼ơ֥Ͽ  */

  XtAddCallback(amsk_cancel, XtNcallback, (XtCallbackProc)Amsk_cancel, NULL);
  XtAddCallback(amsk_ok, XtNcallback, (XtCallbackProc)Amsk_ok, NULL);

  return(automask_box);
}

/*  ưޥΥݥåץå  */
int  Automask_pnl(CONSPATS *cons_parts)
{
  int horiz, vert, len;
  RECT rect;
  Arg  args[2], args1[1];
  Display *dsp;
  GC  gc;
  Font fnt1, fnt2;            /*  եȻ  */
  char str[5];

  Wget_wrk(prgid->pwid, &rect);  /*  ɥɽΰΰ  */

  horiz = ((rect.c.right - rect.c.left) - 200) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 150) / 2;
  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)horiz);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)vert);

  XtSetValues( prgid->automsk.main_pnl, args, XtNumber(args) );
                                              /*  ܥååȤ  */

  dsp = XtDisplay( prgid->automsk.main_pnl );
  gc = DefaultGC( dsp, DefaultScreen( dsp ) );

  fnt1 = XLoadFont( dsp, "-*-bold-*--16-*" );
  fnt2 = XLoadFont( dsp, "-*-bold-*--13-*" );
                                        /* եȾФ  */
  XSetFont(dsp, gc, fnt2);  /*  եȤ򥻥åȤ  */
  XSetForeground(dsp, gc, BLACK);  /*  ʿ  */

  sprintf( str, "%4.2f", cons_parts->maskpnl.mag );
  XtSetArg( args1[0], XtNstring, (XtArgVal)str );
  XtSetValues( amsk_mag, args1, 1 );

  sprintf( str, "%4d", cons_parts->maskpnl.un );
  XtSetArg( args1[0], XtNstring, (XtArgVal)str );
  XtSetValues( range_max, args1, 1 );

  sprintf( str, "%4d", cons_parts->maskpnl.ov );
  XtSetArg( args1[0], XtNstring, (XtArgVal)str );
  XtSetValues( range_min, args1, XtNumber(args1) );

  /*  ʸȤϡåȤɽƤǤʤȥ顼Ǥ  */
  XSetFont(dsp, gc, fnt1);  /*  եȤ򥻥åȤ  */
  len = strlen(amsk_label[0]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      60, 25, amsk_label[0], len );
  XSetFont(dsp, gc, fnt2);  /*  եȤ򥻥åȤ  */
  len = strlen(amsk_label[1]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      38, 60, amsk_label[1], len );
  len = strlen(amsk_label[2]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      165, 60, amsk_label[2], len );
  len = strlen(amsk_label[3]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      20, 86, amsk_label[3], len );
  len = strlen(amsk_label[4]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      14, 110, amsk_label[4], len );
  len = strlen(amsk_label[5]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      54, 110, amsk_label[5], len );
  len = strlen(amsk_label[6]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prgid->automsk.main_pnl ), gc,
                                      134, 110, amsk_label[6], len );
  return(1);
}
