#include <stdlib.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/extensions/XShm.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

/*  ̾    nn ĤΥޥȥꥯΥԥͤʿѤ  */
int    Bmp_reduce(XImage *sgid, RECT sr, XImage *dgid, RECT dr)
{
    int     ix, iy, k, l;
    int     xn, yn;   /*  Ψ  */
    int     count;
    int     xnum, ynum;  /*  ºݤʿѤޥȥꥯȽĤĹ  */
    int     xmt, ymt;    /*  n X n γʻҤ˲ͭ뤫  */
    int     col_flg;     /*  ʻοƱɤ  */
    PNT   pos;         /*  Τɤκɸ򼨤Ƥ뤫  */
    PNT   w_pos;       /*  ɸ  */
    CSPEC csp;  /*  顼  */
    unsigned long    color_a, color_b, color_c;
    unsigned long    cv_col[3];    /*  ƿΥԥͤ  */
    unsigned long   col = 0, col_buf = 0;    /*  顼  */

    //gget_csp(sgid, &csp);  /*  顼Ф  */

    xn = ((sr.c.right - sr.c.left) + (dr.c.right - dr.c.left - 1)) /
                                               (dr.c.right - dr.c.left);

    yn = ((sr.c.bottom - sr.c.top) + (dr.c.bottom - dr.c.top - 1)) /
                                               (dr.c.bottom - dr.c.top);
    xnum = xn; ynum = yn;

    xmt = ((sr.c.right - sr.c.left) + (xn >> 1) + 1) / xn;
    ymt = ((sr.c.bottom - sr.c.top) + (yn >> 1) + 1) / yn;

    for(iy = 0; iy < ymt; iy ++)
    {
        for(ix = 0; ix < xmt; ix ++)
        {
            pos.x = ix * xn + sr.c.left;
            pos.y = iy * yn + sr.c.top;
            xnum = xn; ynum = yn;
            color_a = 0; color_b = 0; color_c = 0;
            count = 0;
            col_flg = 0;
            if( (pos.x + xnum) > sr.c.right )
                xnum = sr.c.right - pos.x;
            if( (pos.y + ynum) > sr.c.bottom )
                ynum = sr.c.bottom - pos.y;

            for(k = 0; k < ynum; k ++, pos.y ++)
            {
                pos.x = ix * xn + sr.c.left;
                for(l = 0; l < xnum; l ++, pos.x ++)
                {
		  col = Getpixels(sgid, pos, csp, cv_col);
                                         /*  ƿΥԥͤФ  */
                    if( k == 0 && l == 0 )
		    {
                        col_buf = col;
	            }
                    else if( col_buf != col )
		    {
                        col_flg = 1;
		    }
                    count ++;
                    color_a += cv_col[0];
                    color_b += cv_col[1];
                    color_c += cv_col[2];
                }
            }
            if(col_flg == 1)  /*  ֿФ  */
            {
                cv_col[0] = (color_a + count / 2) / count;
                cv_col[1] = (color_b + count / 2) / count;
                cv_col[2] = (color_c + count / 2) / count;
            }
            w_pos.x = dr.c.left + ix;
            w_pos.y = dr.c.top + iy;
            if(w_pos.x >= dr.c.left && w_pos.x < dr.c.right &&
                       w_pos.y >= dr.c.top && w_pos.y < dr.c.bottom)
              Putrgb(dgid, w_pos, csp, cv_col);
                  /*  sgid  w_pos  cv_col[] ԥͤ  */
        }
    }
    return(0);
}

/*  褷ϰϤ׻Ƥ  */
void    Redus_bounds(RECT *s_rect, RECT *d_rect, int zoom, int b_size,
                           PNT sp, PNT ep, RECT imag_rect, RECT zoom_rect)
{
    RECT  buf_rect;

    if(sp.x < ep.x)
    {
      buf_rect.c.left = sp.x;
      buf_rect.c.right = ep.x;
    }
    else
    {
      buf_rect.c.left = ep.x;
      buf_rect.c.right = sp.x;
    }
    if(sp.y < ep.y)
    {
      buf_rect.c.top = sp.y;
      buf_rect.c.bottom = ep.y;
    }
    else
    {
      buf_rect.c.top = ep.y;
      buf_rect.c.bottom = sp.y;
    }

    /*  ̾ΰ׻  */
    s_rect->c.left = buf_rect.c.left - (b_size + 1) / 2;
    s_rect->c.top = buf_rect.c.top - (b_size + 1) / 2;
    if(s_rect->c.left < imag_rect.c.left)
      s_rect->c.left = imag_rect.c.left;
    if(s_rect->c.top < imag_rect.c.top)
        s_rect->c.top = imag_rect.c.top;

    s_rect->c.right = buf_rect.c.right + (b_size + 1) / 2;
    s_rect->c.bottom = buf_rect.c.bottom + (b_size + 1) / 2;
    if(s_rect->c.right > imag_rect.c.right)
        s_rect->c.right = imag_rect.c.right;
    if(s_rect->c.bottom > imag_rect.c.bottom)
        s_rect->c.bottom = imag_rect.c.bottom;

    /*  ̾ΰ׻  */
    d_rect->c.left = (s_rect->c.left - imag_rect.c.left) / zoom
                                           + zoom_rect.c.left;
    d_rect->c.top = (s_rect->c.top - imag_rect.c.top) / zoom
                                           + zoom_rect.c.top;
    d_rect->c.right = (s_rect->c.right - imag_rect.c.left + (zoom - 1)) / zoom
                                                    + zoom_rect.c.left;
    d_rect->c.bottom = (s_rect->c.bottom - imag_rect.c.top + (zoom - 1)) / zoom
                                                    + zoom_rect.c.top;

    /*  üͭ뤫⤷ʤΤ,
        ̾ΰ򸵤ˤ⤦ٽ̾ΰ׻  */
    s_rect->c.left = (d_rect->c.left - zoom_rect.c.left) * zoom
                                                        + imag_rect.c.left;
    s_rect->c.top = (d_rect->c.top - zoom_rect.c.top) * zoom
                                                        + imag_rect.c.top;
    s_rect->c.right = (d_rect->c.right - zoom_rect.c.left) * zoom
                                                        + imag_rect.c.left;
    s_rect->c.bottom = (d_rect->c.bottom - zoom_rect.c.top) * zoom
                                                        + imag_rect.c.top;
    /*  s_rect  imag_rect Ǽ  */
    if(s_rect->c.left < imag_rect.c.left)
      s_rect->c.left = imag_rect.c.left;
    if(s_rect->c.top < imag_rect.c.top)
        s_rect->c.top = imag_rect.c.top;
    if(s_rect->c.right > imag_rect.c.right)
        s_rect->c.right = imag_rect.c.right;
    if(s_rect->c.bottom > imag_rect.c.bottom)
        s_rect->c.bottom = imag_rect.c.bottom;
}

/*  ΰν  */
void    Init_zoomrect(BMPPALA *bmp_plm)
{
    bmp_plm->zoom = 1;          /*  Ψ  */

    bmp_plm->zoom_rect.c.left = 0;
    if(bmp_plm->org_size.h > bmp_plm->wid_size.h)
        bmp_plm->zoom_rect.c.right = bmp_plm->wid_size.h;
    else
        bmp_plm->zoom_rect.c.right = bmp_plm->org_size.h;
    bmp_plm->zoom_rect.c.top = 0;
    if(bmp_plm->org_size.v > bmp_plm->wid_size.v)
        bmp_plm->zoom_rect.c.bottom = bmp_plm->wid_size.v;
    else
        bmp_plm->zoom_rect.c.bottom = bmp_plm->org_size.v;
                 /*  ɽƤʬμºݤβΰ  */

    bmp_plm->drw_rect =  bmp_plm->zoom_rect;
                 /*  ɽƤʬβ̤βΰ  */
}

/*  ̰ưʤɤǥɥɽΰϰϤۤƤʤåƤ  */
void    Chk_wrect(RECT org_rect, RECT *zoom_rect,
                                                 RECT *drw_rect, int zoom)
{
    SIZE       org_size;    /*  org_rect ȹ⤵  */
    SIZE       drw_size;    /*  drw_rect ȹ⤵  */
    SIZE       zoom_size;   /*  zoom_rect ȹ⤵  */

    org_size.h = org_rect.c.right - org_rect.c.left;
    org_size.v = org_rect.c.bottom - org_rect.c.top;

    drw_size.h = drw_rect->c.right - drw_rect->c.left;
    drw_size.v = drw_rect->c.bottom - drw_rect->c.top;

    zoom_size.h = drw_size.h / zoom;
    if(drw_size.h % zoom)
        zoom_size.h += 1;
    zoom_size.v = drw_size.v / zoom;
    if(drw_size.v % zoom)
        zoom_size.v += 1;

    /*  βϰ֤ۤʤ褦  */
    if(zoom_rect->c.left < org_rect.c.left)
        zoom_rect->c.left = org_rect.c.left;
    if(zoom_rect->c.top < org_rect.c.top)
        zoom_rect->c.top = org_rect.c.top;

    /*  μºݤɽα  */
    zoom_rect->c.right = zoom_rect->c.left + zoom_size.h;
    zoom_rect->c.bottom = zoom_rect->c.top + zoom_size.v;

    /*  βϰ֤ۤʤ褦  */
    if(zoom_rect->c.right > org_rect.c.right)
    {
        zoom_rect->c.right = org_rect.c.right;
        zoom_rect->c.left = zoom_rect->c.right - zoom_size.h;
    }
    if(zoom_rect->c.bottom > org_rect.c.bottom)
    {
        zoom_rect->c.bottom = org_rect.c.bottom;
        zoom_rect->c.top = zoom_rect->c.bottom - zoom_size.v;
    }

    if(zoom_size.h > org_size.h)
    {
        zoom_rect->c.left = org_rect.c.left;
        zoom_rect->c.right = org_rect.c.right;
        drw_rect->c.left = drw_rect->c.left +
                                      (drw_size.h - org_size.h * zoom) / 2;
        drw_rect->c.right = drw_rect->c.left + org_size.h * zoom;
    }
    if(zoom_size.v > org_size.v)
    {
        zoom_rect->c.top = org_rect.c.top;
        zoom_rect->c.bottom = org_rect.c.bottom;
        drw_rect->c.top = drw_rect->c.top +
                                      (drw_size.v - org_size.v * zoom) / 2;
        drw_rect->c.bottom = drw_rect->c.top + org_size.v * zoom;
    }
}

/*    ɽʬμºݤβΰ׻    */
void    Zoom_point(BMPPALA *bmp_plm)
{
  /*    硿̾ˡ(org_bmp)ˤºݤɽΰ(zoom_rect)
        ׻롣
        硿̾β濴ȡ硿̾β濴碌뤿
        Τ褦ʴؿä
        ɥ礭Ѥ⤳δؿ̲᤹롣    */

    RECT  wid_rect;   /*  ɥΰ  */

    //gget_fra(bmp_plm->imag_gid, &wid_rect); /*  ĶΰĴ٤  */

    Wget_wrk(prgid->canv_wid, &wid_rect); /*  ɥɽΰΰ  */

    bmp_plm->drw_rect = wid_rect;

    if(bmp_plm->zoom < 1)     /*    ݣܤʤɤˤʤʤ褦ˤƤ    */
    {
        bmp_plm->zoom = 1;
        return;
    }

    /*  ɽʬμºݤβΰ׻  */
    bmp_plm->zoom_rect.c.left =
      (bmp_plm->zoom_rect.c.left + bmp_plm->zoom_rect.c.right) / 2
                 - (wid_rect.c.right - wid_rect.c.left) / (2 * bmp_plm->zoom);
    bmp_plm->zoom_rect.c.top =
      (bmp_plm->zoom_rect.c.top + bmp_plm->zoom_rect.c.bottom) / 2
                -  (wid_rect.c.bottom - wid_rect.c.top) / (2 * bmp_plm->zoom);
}

/*    ̾ɽ  */
void    Zoom(BMPPALA *bmp_plm)
{
    RECT  wid_rect;   /*  ɥΰ  */
    RECT  cls_rect;   /*  ХåȤɤĤ֤ΰ  */
    DCM   mode = G_STORE | G_CVFORM | G_CVCOLOR;  /*  ⡼  */
    PAT   clspat = {{0, 16, 16, 0x00a0a0a0, WHITE, FILL100}};
  Display  *dsp;
  Window    win;

  DEBUG_PRINT(("Zoom()\n"));

  dsp = XtDisplay( prgid->canv_wid );
  win = XtWindow( prgid->canv_wid );

    //gget_fra(bmp_plm->imag_gid, &wid_rect); /*  ĶΰĴ٤  */

    wid_rect.c.left = 0; wid_rect.c.top = 0;
    wid_rect.c.right  = bmp_plm->wid_size.h;
    wid_rect.c.bottom = bmp_plm->wid_size.v;

    Gfil_rec(bmp_plm->imag_xim, wid_rect, &clspat, 0, mode);
                                           /*  imag_gid ΰɤĤ֤  */
    bmp_plm->drw_rect = wid_rect;

    if(bmp_plm->zoom < 1)
    {
        bmp_plm->zoom = 1;
        return;
    }

    Chk_wrect(bmp_plm->org_bmp.bounds, &(bmp_plm->zoom_rect),
                                        &(bmp_plm->drw_rect), bmp_plm->zoom);
         /*  ̰ưʤɤǥɥɽΰϰϤۤƤʤå  */

/*    bmp_plm->drw_rect  wid_rect ⾮
      ¾ʬɤĤ֤                        */
    if(wid_rect.c.left < bmp_plm->drw_rect.c.left)
    {
        cls_rect.c.left   = wid_rect.c.left;
        cls_rect.c.right  = bmp_plm->drw_rect.c.left;
        cls_rect.c.top    = wid_rect.c.top;
        cls_rect.c.bottom = wid_rect.c.bottom;
        Gfil_rec(bmp_plm->imag_xim, cls_rect, &clspat, 0, 0);
    }                                      /*  ɽɤĤ֤  */
    if(wid_rect.c.right > bmp_plm->drw_rect.c.right)
    {
        cls_rect.c.left   = bmp_plm->drw_rect.c.right;
        cls_rect.c.right  = wid_rect.c.right;
        cls_rect.c.top    = wid_rect.c.top;
        cls_rect.c.bottom = wid_rect.c.bottom;
        Gfil_rec(bmp_plm->imag_xim, cls_rect, &clspat, 0, 0);
    }                                      /*  ɽɤĤ֤  */
    if(wid_rect.c.top < bmp_plm->drw_rect.c.top)
    {
        cls_rect.c.left   = wid_rect.c.left;
        cls_rect.c.right  = wid_rect.c.right;
        cls_rect.c.top    = wid_rect.c.top;
        cls_rect.c.bottom = bmp_plm->drw_rect.c.top;
        Gfil_rec(bmp_plm->imag_xim, cls_rect, &clspat, 0, 0);
    }                                      /*  ɽɤĤ֤  */
    if(wid_rect.c.bottom > bmp_plm->drw_rect.c.bottom)
    {
        cls_rect.c.left   = wid_rect.c.left;
        cls_rect.c.right  = wid_rect.c.right;
        cls_rect.c.top    = bmp_plm->drw_rect.c.bottom;
        cls_rect.c.bottom = wid_rect.c.bottom;
        Gfil_rec(bmp_plm->imag_xim, cls_rect, &clspat, 0, 0);
    }                                      /*  ɽɤĤ֤  */

    Copy_tiles(bmp_plm->org_xim, &(bmp_plm->zoom_rect),
                bmp_plm->imag_xim, &(bmp_plm->drw_rect), bmp_plm->zoom, 0);
                                           /*  礷ƥԡ  */
    Gcop_bmp(bmp_plm->imag_xim, &wid_rect,
                      bmp_plm->canv_xim, &wid_rect, NULL, 0);
                                    /*  Ȳ饦ɥ̤إԡ  */

    XShmPutImage( bmp_plm->disp, bmp_plm->canv_gid, bmp_plm->canv_gc,
                               bmp_plm->canv_xim, 0, 0, 0, 0,
                             bmp_plm->wid_size.h, bmp_plm->wid_size.v, False );
                                            /*  ɥɽ  */
    //Gcop_bmp(&bmp_plm->imag_bmp, &(bmp_plm->drw_rect),
    //                  &bmp_plm->canv_bmp, &(bmp_plm->drw_rect), NULL, 0);
                                            /*  ɽإԡ  */
    Gcop_bmp(bmp_plm->imag_xim, &wid_rect,
                      bmp_plm->ibuf_xim, &wid_rect, NULL, 0);
                                    /*  ȲǼѲإԡ  */
}

void ZoomIn(Widget w, XEvent *event, String *params, int num_params)
                                                      /*  Magnify screen  */
{
  int width, height;

  bmpplm->zoom += 1;

  Zoom_point(bmpplm);  /*  ɽʬμºݤβΰ׻  */

  Zoom(bmpplm);  /*  ̾ɽ  */

  Show_zoom(bmpplm, consparts);     /*  Ψɽ  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

void ZoomOut(Widget w, XEvent *event, String *params, int num_params)
                                                       /*  Reduce screen  */
{
  int width, height;

  bmpplm->zoom -= 1;

  Zoom_point(bmpplm);  /*  ɽʬμºݤβΰ׻  */

  Zoom(bmpplm);  /*  ̾ɽ  */

  Show_zoom(bmpplm, consparts);     /*  Ψɽ  */

  Rest_mask(&bmpplm->org_bmp.bounds, &bmpplm->zoom_rect, bmpplm->mask_mat,
              &bmpplm->wid_rect, &bmpplm->drw_rect, bmpplm->mask_scr,
                                                                bmpplm->zoom);
                                    /*  ޥ̤ޥ꡼  */

  Harf_tone(prgid->mask_mode, bmpplm);
                /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  Set_sclbar(prgid->rbar_pid, prgid->bbar_pid,
		 bmpplm->zoom_rect, bmpplm->org_bmp.bounds);
                                  /*  ɥС  */
}

/*  ɽ֤ΰư  */
void Imag_mov(BMPPALA *bmp_plm, int code)
{
    switch(code)
    {
        case    0:        /*  ڡ  줿*/
            if(bmp_plm->org_bmp.bounds.c.top < bmp_plm->zoom_rect.c.top)
            {
                bmp_plm->zoom_rect.c.top -=
                                  bmp_plm->wid_size.v / (2 * bmp_plm->zoom);
                Zoom(bmp_plm);   /*    ̾  */
            }
            break;
        case    1:        /*  ڡ  줿*/
            if(bmp_plm->org_bmp.bounds.c.bottom > bmp_plm->zoom_rect.c.bottom)
            {
                bmp_plm->zoom_rect.c.top +=
                                  bmp_plm->wid_size.v / (2 * bmp_plm->zoom);
                Zoom(bmp_plm);   /*    ̾  */
            }
            break;
        case    2:        /*  ڡ  줿*/
            if(bmp_plm->org_bmp.bounds.c.right > bmp_plm->zoom_rect.c.right)
            {
                bmp_plm->zoom_rect.c.left +=
                                  bmp_plm->wid_size.h / (2 * bmp_plm->zoom);
                Zoom(bmp_plm);   /*    ̾  */
            }
            break;
        case    3:        /*  ڡ  줿*/
            if(bmp_plm->org_bmp.bounds.c.left < bmp_plm->zoom_rect.c.left)
            {
                bmp_plm->zoom_rect.c.left -=
                                  bmp_plm->wid_size.h / (2 * bmp_plm->zoom);
                Zoom(bmp_plm);   /*    ̾  */
            }
            break;
    }
}
