/*
	consevt.C		xbrush

	󥽡륦ɥ٥
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/cursorfont.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

/*  󥽡륦ɥ礭ѹ  */
void    Chg_conssize(PRGID *prg_id, BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
    int colscr_width, colscr_height;

    printf("Chg_conssize()\n");
    colscr_width = cons_parts->slct_col.colbar[0].vol_rect.c.right
                    - cons_parts->slct_col.colbar[0].vol_rect.c.left;
    colscr_height = bmp_plm->cons_rect.c.bottom - 78
                    - cons_parts->slct_col.colbar[0].vol_rect.c.top;

    if(bmp_plm->cons_rect.c.bottom > 718)
    {
      cons_parts->slct_col.colbox.c.top   = 650;
      cons_parts->slct_col.colbox.c.bottom = cons_parts->slct_col.colbox.c.top + 60;
      XtResizeWidget(cons_parts->slct_col.colbar[0].vol_pid,
                            colscr_width, 256, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[1].vol_pid,
                            colscr_width, 256, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[2].vol_pid,
                            colscr_width, 256, 1);
    }
    else if(bmp_plm->cons_rect.c.bottom >= C_HEIGHT)
    {
      cons_parts->slct_col.colbox.c.top   = bmp_plm->cons_rect.c.bottom - 68;
      cons_parts->slct_col.colbox.c.bottom = cons_parts->slct_col.colbox.c.top + 60;
      XtResizeWidget(cons_parts->slct_col.colbar[0].vol_pid,
                            colscr_width, colscr_height, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[1].vol_pid,
                            colscr_width, colscr_height, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[2].vol_pid,
                            colscr_width, colscr_height, 1);
    }
    else
    {
      cons_parts->slct_col.colbox.c.top   = C_HEIGHT - 68;
      cons_parts->slct_col.colbox.c.bottom = cons_parts->slct_col.colbox.c.top + 60;
      XtResizeWidget(cons_parts->slct_col.colbar[0].vol_pid,
                                      colscr_width, C_LENG, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[1].vol_pid,
                                      colscr_width, C_LENG, 1);
      XtResizeWidget(cons_parts->slct_col.colbar[2].vol_pid,
                                      colscr_width, C_LENG, 1);
    }

}

/*  򿧤  */
void    Shw_color(BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
    cons_parts->slct_col.sel_col =
               0x10000000 | cons_parts->slct_col.colbar[0].size << 16 |
                            cons_parts->slct_col.colbar[1].size << 8 |
                            cons_parts->slct_col.colbar[2].size;
                                             /*  򿧤  */
    Disp_selcol(bmp_plm->cons_gc, cons_parts);  /*  꿧ɽ  */

    bmp_plm->src_col = cons_parts->slct_col.sel_col;
                                         /*  bmp_plm ¤Τإ顼ͤ  */
}

/*  ܥ塼Υࡼư  */
void Console_Evt(Widget w, caddr_t client_data, caddr_t percent_ptr)
{
  int i;
  float percent = *(float*)percent_ptr;

  if(percent > 1)
      percent = 1;
  if(percent < 0)
      percent = 0;


  if(w == consparts->dens_vol.vol_pid)  /*  ǻξ  */
  {
    consparts->dens_vol.size = percent * 254 + 1;
    Vol_evn((Widget)client_data, w, &consparts->dens_vol,
	                   bmpplm, consparts);/*  ܥ塼।٥  */
    Init_brush_map(consparts);  /*  initiarize bursh map  */
  }
  else if(w == consparts->size_vol.vol_pid)  /*  礭ξ  */
  {
    consparts->size_vol.size = percent * 179 + 1;
    Vol_evn((Widget)client_data, w, &consparts->size_vol,
	                   bmpplm, consparts);/*  ܥ塼।٥  */
    bmpplm->b_size = consparts->size_vol.size;
    Init_brush_map(consparts);  /*  initiarize bursh map  */
  }
  else
    for(i = 0; i < 3; i ++)
                            /*  꿧οͥܥåȥСɽ  */
    {
      if(w == consparts->slct_col.colbar[i].vol_pid)
      {
        consparts->slct_col.colbar[i].size = 255 - percent * 255;
        Vol_evn((Widget)client_data, w, &consparts->slct_col.colbar[i],
	                   bmpplm, consparts);/*  ܥ塼।٥  */
      }
    }

}

/*  ܥ塼।٥  */
void   Vol_evn(Widget wevnt, Widget pid_vol, VOLPARAM *vol_para,
                                      BMPPALA *bmp_plm, CONSPATS *cons_parts)
{
  Cset_val(vol_para->num_pid, 1, &vol_para->size);    /*  ѡĤͤ  */

  if(pid_vol == cons_parts->slct_col.colbar[0].vol_pid ||
     pid_vol == cons_parts->slct_col.colbar[1].vol_pid ||
     pid_vol == cons_parts->slct_col.colbar[2].vol_pid)
      Shw_color(bmp_plm, cons_parts);
                                                    /*  򿧤  */
}

/*  ɥ٥  */
void    Undo_evn(Widget wevnt, Widget pid, PRGID *prg_id, BMPPALA *bmp_plm)
{
  XDefineCursor( XtDisplay(prg_id->pwid), XtWindow(prg_id->pwid),
                  XCreateFontCursor(XtDisplay(prg_id->pwid), XC_watch) );
                                              /*  פѤ  */
  Undo(bmp_plm);      /*  ɥ  */

  Copy_org2orgbuf(bmpplm);    /*  Хåե˵  */

  Harf_tone(prg_id->mask_mode, bmp_plm);
                      /*  ֥ޥ⡼ɡפ֥ޥõ⡼ɡפΤȤ
                                                ̤˥ϡեȡ򤫤  */
  XUndefineCursor( XtDisplay(prg_id->pwid), XtWindow(prg_id->pwid) );
                                              /*  򸵤᤹  */
}
void Exec_undo(Widget w, Widget client_data, caddr_t call_data )/* Exec Undo */
{
  Undo_evn(client_data, w, prgid, bmpplm);  /*  ɥ٥  */
}

/*  ɥå٥  */
void    Lock_evn(Widget wevnt, Widget pid, PRGID *prg_id, BMPPALA *bmp_plm)
{
  if( (prg_id->xb_mode & 0x0020) == 0x0020 )
  {
    prg_id->xb_mode &= 0xFFDF;
  }
  else
  {
    prg_id->xb_mode |= 0x0020;
    Chgxim_orgbuf2undo(bmpplm);
                    /*  orgbuf_xim  undo_xim 촹  */
    //Copy_undo_bmp(bmp_plm);  /*  ɥХåե˲ǡ򥳥ԡ  */
    bmp_plm->undolock_xim = bmp_plm->undo_xim;
  }
  return;
}

void Undo_lock(Widget w, Widget client_data, caddr_t call_data)
                                                  /* Lock Undo buffer */
{
  Lock_evn(client_data, w, prgid, bmpplm);  /*  ɥå٥  */
}

/*  ȥɥǥץ쥹  */
void    Pres_evn(XEvent *wevnt, PRGID *prg_id, BMPPALA *bmp_plm, 
                                              CONSPATS *cons_parts)
{
  if( wevnt->xbutton.button == 1 )  /*  ܥ󣱤줿  */
  {
    if((cons_parts->funcval.func_rect.c.left < wevnt->xbutton.x) &&
            (wevnt->xbutton.x < cons_parts->funcval.func_rect.c.right) &&
            (cons_parts->funcval.func_rect.c.top < wevnt->xbutton.y) &&
            (wevnt->xbutton.y < cons_parts->funcval.func_rect.c.bottom))
                                       /*  ؿվǥå줿  */
    {
        Popdown_mainmenu(prg_id->main_mid, NULL, NULL);
                                           /*  ᥤ˥塼Ĥ  */
        Popup_funcmenu(wevnt, prg_id, bmp_plm, cons_parts);
                                                 /*  ؿ˥塼  */
    }
    else
      if( XtIsRealized(prg_id->func_mid) )
        XtUnmanageChild( prg_id->func_mid );  /*  ؿ˥塼Ĥ  */
  }
  /*
  else
    if( XtIsRealized(prg_id->func_mid) )
      XtUnmanageChild( prg_id->func_mid );  /*  ؿ˥塼Ĥ  */

  Popdown_mainmenu(prg_id->main_mid, NULL, NULL);
                                           /*  ᥤ˥塼Ĥ  */
}

/*  å󥽡륤٥  */
void    Prspd_cons(XEvent *wevnt, PRGID *prg_id, BMPPALA *bmp_plm, 
                                                CONSPATS *cons_parts)
{
    Pres_evn(wevnt, prg_id, bmp_plm, cons_parts);
                                           /*  ȥɥǥץ쥹  */
}

/*  󥽡륦ɥ٥  */
void    Event_console(XEvent *wevnt, PRGID *prg_id, BMPPALA *bmp_plm,
                                               CONSPATS *cons_parts)
{
  switch(wevnt->type)
  {
    case ButtonPress:   /*  ޥΥܥ󤬲줿  */
      Prspd_cons(wevnt, prg_id, bmp_plm, cons_parts);
                                           /*  å󥽡륤٥  */
      break;
    case ButtonRelease:   /*  ޥΥܥ󤬥꡼줿  */
      Popdown_mainmenu(prg_id->main_mid, NULL, NULL);
                                /*  ᥤ˥塼Υݥåץ  */
      break;
    case LeaveNotify:  /*  ɥγ˽Ф  */
      if( XtIsRealized(prg_id->func_mid) )
        XtUnmanageChild( prg_id->func_mid );  /*  ؿ˥塼Ĥ  */
      //XtUnmanageChild( mask_mid );  /*  ˥塼Ĥ  */

      break;
    case Expose:         /* ؤ/ɽ  */
      if(wevnt->xexpose.window == bmp_plm->cons_gid)
      {
        Disp_consw(bmp_plm->cons_gc, cons_parts);
                                /*  󥽡륦ɥɽ  */
      }
      break;
    default:
      break;
  }
}

void Event_cons(Widget w, caddr_t client_data, XEvent *event)
{
  Event_console(event, prgid, bmpplm, consparts);
               /*  󥽡륦ɥ٥  */
}
