/*
	console.C		xbrush

	󥽡륦ɥɽ
*/

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlibint.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include "xbrush.h"

extern PRGID     *prgid;          /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;         /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern char  *cns_label[];     /*  󥽡륦ɥΥ٥  */
extern char  *funcexp[];       /*  ֥饷δؿ  */

/*  ؿɽ  */
void    Draw_func(GC cons_gc, CONSPATS *cons_parts)
{
  Display *dsp;

  int     len;             /*  ʸĹ  */
  int     f_no;            /*  δؿֹ  */
    //PAT   pat;             /*  ѥ  */
    //DCM   mode = G_STORE;  /*  ⡼  */
    //LATTR lat = 2;         /*  °:  :  */
  Font fnt;            /*  եȻ  */

    //pat.spat.kind = 0; pat.spat.hsize = 16; pat.spat.vsize = 16;
    //pat.spat.fgcol = WHITE;         /*  ʿ  */
    //pat.spat.bgcol = WHITE;         /*  طʿ  */
    //pat.spat.mask = FILL100;

  f_no = cons_parts->funcval.func_no;    /*  δؿֹ  */

  dsp = XtDisplay( prgid->cons_wid );
  //win = XtWindow( prgid->cons_wid );

  fnt = XLoadFont( XtDisplay( prgid->cons_wid ), "-*-bold-*--13-*" );
                                        /* եȾФ  */
  //fnt.size.h = 10; fnt.size.v = 12;  /*  ʸ礭򣱣ȾѤ  */
  XSetFont(dsp, cons_gc, fnt);  /*  եȤ򥻥åȤ  */


  //XClearWindow( dsp, win );
  XSetForeground( dsp, cons_gc, WHITE);  /*  ʿ  */
  XFillRectangle( dsp, bmpplm->cons_gid, cons_gc,
              cons_parts->funcval.func_rect.c.left,
              cons_parts->funcval.func_rect.c.top,
              cons_parts->funcval.func_rect.c.right
                             - cons_parts->funcval.func_rect.c.left,
              cons_parts->funcval.func_rect.c.bottom
                             - cons_parts->funcval.func_rect.c.top);
                                                         /*  ɤĤ֤  */
  XSetForeground(dsp, cons_gc, BLACK);  /*  ʿ  */
  XSetLineAttributes(dsp, cons_gc, 2, LineSolid, CapButt, JoinMiter);
                                                  /*   ԥ  */
  XDrawLine( dsp, bmpplm->cons_gid, cons_gc,
        cons_parts->funcval.xaxi.c.left, cons_parts->funcval.xaxi.c.top,
        cons_parts->funcval.xaxi.c.right, cons_parts->funcval.xaxi.c.bottom);
  XDrawLine( dsp, bmpplm->cons_gid, cons_gc,
        cons_parts->funcval.yaxi.c.left, cons_parts->funcval.yaxi.c.top,
        cons_parts->funcval.yaxi.c.right, cons_parts->funcval.yaxi.c.bottom);
                                               /*  ,ɽ  */

  XSetLineAttributes(dsp, cons_gc, 1, LineSolid, CapButt, JoinMiter);

  Drw_graph(cons_gc, cons_parts);      /*  ؿդ򥳥󥽡  */

  len = strlen(funcexp[f_no]);       /*  ؿʸĹĴ٤  */

  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
               cons_parts->funcval.func_rect.c.right - len * 6 - 6,
	       cons_parts->funcval.func_rect.c.top + 15, funcexp[f_no], len);
                                                 /*  ؿοɽ  */

  Init_brush_map(cons_parts);  /*  ֥饷ޥåפ  */
}

/*  꿧ɽ  */
void    Disp_selcol(GC cons_gc, CONSPATS *cons_parts)
{
  Display *dsp;

  unsigned long   pat;     /*  ѥ  */
  PNT   pnt_1, pnt_2;    /*  꿧ɽ  */
    //DCM   mode = G_STORE;  /*  ⡼  */
    //LATTR lat = 2;         /*  °:  :  */

    //pat.spat.kind = 0; pat.spat.hsize = 16; pat.spat.vsize = 16;
  pat = cons_parts->slct_col.sel_col & 0xFFFFFF;  /*  꿧  */
    //pat.spat.bgcol = WHITE;         /*  طʿ  */
    //pat.spat.mask = FILL100;

    //gfil_rec(cons_gc, cons_parts->slct_col.colbox,
    //                                  &pat, 0, mode);  /*  꿧ɽ  */

  dsp = XtDisplay( prgid->cons_wid );
  bmpplm->cons_gid = XtWindow( prgid->cons_wid );

  //XClearWindow( dsp, win );

  XSetForeground(dsp, cons_gc, pat);  /*    */

  XFillRectangle(dsp, bmpplm->cons_gid, cons_gc,
              cons_parts->slct_col.colbox.c.left,
              cons_parts->slct_col.colbox.c.top,
              cons_parts->slct_col.colbox.c.right
                             - cons_parts->slct_col.colbox.c.left,
              cons_parts->slct_col.colbox.c.bottom
                             - cons_parts->slct_col.colbox.c.top);
                                                      /*  꿧ɽ  */

  XSetLineAttributes(dsp, cons_gc, 2, LineSolid, CapButt, JoinMiter);

    /*  ʲ꿧Ȥ  */

  XSetForeground(dsp, cons_gc, BLACK);  /*  ʿ  */

    pnt_1.x = cons_parts->slct_col.colbox.c.left;
    pnt_1.y = cons_parts->slct_col.colbox.c.bottom;
    pnt_2.x = cons_parts->slct_col.colbox.c.left;
    pnt_2.y = cons_parts->slct_col.colbox.c.top;

    XDrawLine(dsp, bmpplm->cons_gid, cons_gc,
                                 pnt_1.x, pnt_1.y, pnt_2.x, pnt_2.y);

    pnt_1.x = cons_parts->slct_col.colbox.c.right;
    pnt_1.y = cons_parts->slct_col.colbox.c.top;
    XDrawLine(dsp, bmpplm->cons_gid, cons_gc,
                                 pnt_1.x, pnt_1.y, pnt_2.x, pnt_2.y);

  XSetForeground(dsp, cons_gc, WHITE);  /*  ʿ  */
    pnt_2.x = cons_parts->slct_col.colbox.c.right;
    pnt_2.y = cons_parts->slct_col.colbox.c.bottom;
    XDrawLine(dsp, bmpplm->cons_gid, cons_gc,
                                 pnt_1.x, pnt_1.y, pnt_2.x, pnt_2.y);

    pnt_1.x = cons_parts->slct_col.colbox.c.left;
    pnt_1.y = cons_parts->slct_col.colbox.c.bottom;
    XDrawLine(dsp, bmpplm->cons_gid, cons_gc,
                                 pnt_1.x, pnt_1.y, pnt_2.x, pnt_2.y);
}

/*  󥽡륦ɥʸ  */
void    Draw_ch(GC cons_gc, CONSPATS *cons_parts)
{

  int    len;
  Display *dsp;

  dsp = XtDisplay( prgid->cons_wid );
  //win = XtWindow( prgid->cons_wid );
  DCM   mode = G_STORE;  /*  ⡼  */
  Font   fnt;            /*  եȻ  */

  fnt = XLoadFont( XtDisplay( prgid->cons_wid ), "-*-bold-*--13-*" );
                                        /* եȾФ  */
    //fnt.size.h = 10; fnt.size.v = 12;  /*  ʸ礭򣱣ȾѤ  */
  XSetFont(dsp, cons_gc, fnt);  /*  եȤ򥻥åȤ  */
  XSetForeground(dsp, cons_gc, BLACK);  /*  ʿ  */

  len = strlen(cns_label[0]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->point_pnt.numx_rect.c.left - 16,
             cons_parts->point_pnt.numx_rect.c.bottom - 2, cns_label[0], len);
                                               /*  ɽ  */

  len = strlen(cns_label[1]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->point_pnt.numy_rect.c.left - 16,
             cons_parts->point_pnt.numy_rect.c.bottom - 2, cns_label[1], len);
                                               /*  ɽ  */

    //fnt.size.h = 12; fnt.size.v = 12;  /*  ʸ礭򣱣  */
    //gset_fon(cons_gid, &fnt);  /*  եȤ򥻥åȤ  */


  len = strlen(cns_label[2]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->zoom_num.num_rect.c.left - 34,
             cons_parts->zoom_num.num_rect.c.bottom - 2, cns_label[2], len);
                                                /*  ᡡxɽ  */

  len = strlen(cns_label[3]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->dens_vol.num_rect.c.left - 38,
             cons_parts->dens_vol.num_rect.c.bottom - 2, cns_label[3], len);
                                               /*  ɽ  */

  len = strlen(cns_label[4]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->size_vol.num_rect.c.left - 38,
             cons_parts->size_vol.num_rect.c.bottom - 2, cns_label[4], len);
                                               /*  ɽ  */

  len = strlen(cns_label[5]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->slct_col.colbar[0].num_rect.c.left + 12,
             cons_parts->slct_col.colbar[0].num_rect.c.top - 6,
                                                        cns_label[5], len);
                                               /*  ҡɽ  */

  len = strlen(cns_label[6]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->slct_col.colbar[1].num_rect.c.left + 12,
             cons_parts->slct_col.colbar[1].num_rect.c.top - 6,
                                                        cns_label[6], len);
                                               /*  ǡɽ  */

  len = strlen(cns_label[7]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, bmpplm->cons_gid, cons_gc,
             cons_parts->slct_col.colbar[2].num_rect.c.left + 12,
             cons_parts->slct_col.colbar[2].num_rect.c.top - 6,
                                                        cns_label[7], len);
                                               /*  ¡ɽ  */


}

/*  󥽡륦ɥɽ  */
void    Disp_consw(GC cons_gc, CONSPATS *cons_parts)
{
  static Widget  c_bar, c_disp;

  Disp_selcol(cons_gc, cons_parts);  /*  꿧ɽ  */
  Draw_func(cons_gc, cons_parts);    /*  ؿɽ  */
  Draw_ch(cons_gc, cons_parts);   /*  󥽡륦ɥʸ  */
}
