/*
	drwfunc.c		xbrush

	֥饷ؿν
*/

#include <stdio.h>
#include <math.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;       /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern char  *funcexp[];          /*  ֥饷δؿ  */

double    func_0(double x)  /*  y = 1  */
{
    double    y;
    if( x >= 1 )
        y = 0;
    else
        y = 1;
    return( y );
}

double    func_1(double x)  /*  y = 1 - x^2  */
{
    double    y;
    if( x >= 1 )
        y = 0;
    else
        y = 1 - x * x;
    return( y );
}

double    func_2(double x )  /*  y = 1 - x  */
{
    double    y;
    if( x >= 1 )
        y = 0;
    else
        y = 1 - x;
    return( y );
}

double    func_3(double x)  /*  y = 1-sqr(x)  */
{
    double    y;
    if( x >= 1 )
        y = 0;
    else
        y = 1 - sqrt( x );
    return( y );
}

double Brush_func(int f_no, double x)  /*  ƥ֥饷ؿФ뿧ǻ  */
{
    double y;

    switch(f_no)
    {
        case 0:
            y = func_0( x );  /*  y = 1  */
            break;
        case 1:
            y = func_1( x );  /*  y = 1 - x^2  */
            break;
        case 2:
            y = func_2( x );  /*  y = 1 - x  */
            break;
        case 3:
            y = func_3( x );  /*  y = 1-sqr(x)  */
            break;
        default:
            y = 0;
      }
      if( y > 80 )
          y = 80;
      return( y );
}

void Drw_graph(GC cons_gc, CONSPATS *cons_parts)
                                         /*  ؿդ򥳥󥽡  */
{
  Display *dsp;
  Window win;
    double     i, ans;
    PNT   pnt;
    //DCM   mode = G_STORE;  /*  ⡼  */

  dsp = XtDisplay( prgid->cons_wid );
  win = XtWindow( prgid->cons_wid );

  for ( i = 0 ; i < 1 ; i += 0.0125 )
  {
    ans = Brush_func(cons_parts->funcval.func_no, i);
    pnt.x = cons_parts->funcval.xaxi.c.left + i * 80;
    pnt.y = cons_parts->funcval.yaxi.c.top - ans * 80;
    if( pnt.y < cons_parts->funcval.yaxi.c.top - 80 )
        pnt.y = cons_parts->funcval.yaxi.c.top - 80;

    XDrawPoint(dsp, win, cons_gc, pnt.x, pnt.y);
                                                /*  ؿ˱äǤ  */
  }
}
