/*
	tabletto.C		xbrush

	֥åȴϢ
*/

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/extensions/XInput.h>
#include "xbrush.h"

extern PRGID     *prgid;        /*  ƼΣɣ  */
extern BMPPALA   *bmpplm;       /*  ӥåȥޥå  */
extern CONSPATS  *consparts;    /*  󥽡ѡ  */

extern XFontStruct *info;    /*  Font Struct */

extern char defaultTranslations[];

extern int  motion_type;
extern int  button_press_type;
extern int  button_release_type;
extern int  key_press_type;
extern int  key_release_type;
extern int  proximity_in_type;
extern int  proximity_out_type;

//static Display	*disp;
static Widget   tab_paned, tab_vport;
static XDeviceInfo  *dev_info, *infobuf;

static String *listdev;    /*  XInputΥǥХꥹ  */
static int  mangn = 100;  /*  ֥åɮΨ  */
static int  dev_no = -1;  /*  򤷤ǥХֹ  */

char   *tab_label[] = {(char[]){"Set Tabletto parameter"},
                       (char[]){"Cut off Prssure:"},
                       (char[]){"Prssure magnifaction"},
                      };   /*  ֥åѥͥΥ٥  */

/*  ǥХΥץ  */
int    Device_open(int num)
{
    Window		rwin;
    unsigned long	screen;
    XEventClass		evlst[5];
    //XDevice		*device;
    XInputClassInfo	*ipinfo;
    //Display	*disp;
    int          i;

    DEBUG_PRINT(("Device_open() dev_no:%d  use:%d\n", num, infobuf[num].use));

    if(infobuf[num].use != 4)
      return(-1);    /*  ݥ󥿥ǥХǤʤ  */

    //disp = XOpenDisplay(NULL);
    screen = DefaultScreen(bmpplm->disp);

    rwin   = RootWindow(bmpplm->disp, screen);/*  롼ȥɥIDĴ٤  */

    prgid->xidev = XOpenDevice(bmpplm->disp, infobuf[num].id);    /*  ǥХ򥪡ץ  */

    DEBUG_PRINT(("Device_open() device_id:%d  num_class:%d\n", prgid->xidev->device_id, prgid->xidev->num_classes));

    if (prgid->xidev->num_classes > 0)
    {                        /*  ɤΥ٥ȤȤ뤫  */
	for (ipinfo = prgid->xidev->classes, num = 0; num < prgid->xidev->num_classes;
                                                             ipinfo++, num++)
        {
            DEBUG_PRINT(("Device_open() input_class:%d\n", ipinfo->input_class));

	    switch (ipinfo->input_class)
            {

	    case ButtonClass:
                DEBUG_PRINT(("Device_open() ButtonClass\n"));
                DeviceButtonPress(prgid->xidev, button_press_type, evlst[0]);
	        DeviceButtonRelease(prgid->xidev, button_release_type, evlst[1]);
		break;

	    case ValuatorClass:
                DEBUG_PRINT(("Device_open() ValuatorClass\n"));
		DeviceMotionNotify(prgid->xidev, motion_type, evlst[2]);
		ProximityIn(prgid->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prgid->xidev, proximity_out_type, evlst[4]);
		break;
		
	    case FeedbackClass:
                DEBUG_PRINT(("Device_open():  FeedbackClass\n"));
		DeviceMotionNotify(prgid->xidev, motion_type, evlst[2]);
		ProximityIn(prgid->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prgid->xidev, proximity_out_type, evlst[4]);
		break;
		
	    case OtherClass:
                DEBUG_PRINT(("Device_open():  OtherClass\n"));
		DeviceMotionNotify(prgid->xidev, motion_type, evlst[2]);
		ProximityIn(prgid->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prgid->xidev, proximity_out_type, evlst[4]);
		break;

	    default:
		break;
	    }
	}
       for( i = 0; i < 5; i ++ )
       {
           DEBUG_PRINT(("Device_open() evlst[%d]:%d\n", i, evlst[i]));
           if( evlst[i] == 0 )
               break;
       }
       DEBUG_PRINT(("Device_open() i = %d\n", i));
       if (XSelectExtensionEvent(bmpplm->disp, rwin, evlst, i))
       {                       /*  XNextEvent Ǽ褦ˤƤ  */
           return(-1);
       }
    }

    DEBUG_PRINT(("Device_open() motion_type:%d  proximity_in_type:%d  proximity_out_type:%d\n",
                                motion_type, proximity_in_type, proximity_out_type));
    DEBUG_PRINT(("Device_open() button_press_type:%d  button_release_type:%d\n",
                                button_press_type, button_release_type));

    return(1);
}


/*    ֥åȥɥ饤Ф󤷤Ƥ뤫    */
int    Settabletto(BMPPALA *bmp_plm, PRGID *prg_id, char *dev)
{
  XEvent   event;
    Window		rwin;
    unsigned long	screen;
    XEventClass		evlst[5];
    XInputClassInfo	*ipinfo;
    int i, num_dev, err;

    if(dev == NULL)
      return(-1);

    DEBUG_PRINT(("SetTabletto() 1\n"));
    screen = DefaultScreen(bmp_plm->disp);
    DEBUG_PRINT(("SetTabletto() DefaultScreen = %d\n", screen));

    infobuf = XListInputDevices(bmp_plm->disp, &num_dev);
                    /*   X-Window ǻѤǤǥХĴ٤Ƥ  */

    for(i = 0; i < num_dev; i ++)
    {                  /*  ꤷǥХȤ뤫å  */
      DEBUG_PRINT(("device XID:%d name:%s use:%d\n",
                    infobuf[i].id, infobuf[i].name, infobuf[i].use));
      if ( strcmp(infobuf[i].name, dev) == 0 )
      {
	    dev_info = &infobuf[i];
            break;
      }
    }

    if (i >= num_dev)
    {
        DEBUG_PRINT(("Settabletto():%s cannot use\n", dev));
        return(-1);
    }

    rwin   = RootWindow(bmp_plm->disp, screen);   /*  롼ȥɥIDĴ٤  */

    prg_id->xidev = XOpenDevice(bmp_plm->disp, dev_info->id);    /*  ǥХ򥪡ץ  */
    DEBUG_PRINT(("SetTabletto() device_id:%d  num_class:%d\n", prg_id->xidev->device_id, prg_id->xidev->num_classes));

    if (prg_id->xidev->num_classes > 0)
    {                        /*  ɤΥ٥ȤȤ뤫  */
	for (ipinfo = prg_id->xidev->classes, i=0; i < prg_id->xidev->num_classes;
                                                             ipinfo++, i++)
        {
            DEBUG_PRINT(("SetTabletto() ipinfo->input_class:%d\n", ipinfo->input_class));
	    switch (ipinfo->input_class)
            {

	    case ButtonClass:
                DEBUG_PRINT(("Settabletto():  ButtonClass\n"));
                DeviceButtonPress(prg_id->xidev, button_press_type, evlst[0]);
	        DeviceButtonRelease(prg_id->xidev, button_release_type, evlst[1]);
		break;

	    case ValuatorClass:
                DEBUG_PRINT(("Settabletto():  ValuatorClass\n"));
		DeviceMotionNotify(prg_id->xidev, motion_type, evlst[2]);
		ProximityIn(prg_id->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prg_id->xidev, proximity_out_type, evlst[4]);
		break;

	    case FeedbackClass:
                DEBUG_PRINT(("Settabletto():  FeedbackClass\n"));
		DeviceMotionNotify(prg_id->xidev, motion_type, evlst[2]);
		ProximityIn(prg_id->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prg_id->xidev, proximity_out_type, evlst[4]);
		break;
		
	    case OtherClass:
                DEBUG_PRINT(("Settabletto():  OtherClass\n"));
		DeviceMotionNotify(prg_id->xidev, motion_type, evlst[2]);
		ProximityIn(prg_id->xidev, proximity_in_type, evlst[3]);
	        ProximityOut(prg_id->xidev, proximity_out_type, evlst[4]);
		break;

	    default:
		break;
	    }
	}

       DEBUG_PRINT(("Settabletto() motion_type:%d  proximity_in_type:%d  proximity_out_type:%d\n",
                                       motion_type, proximity_in_type, proximity_out_type));
       DEBUG_PRINT(("Settabletto() button_press_type:%d  button_release_type:%d\n",
                                       button_press_type, button_release_type));

       for( i = 0; i < 5; i ++ )
       {
           DEBUG_PRINT(("Settabletto() evlst[%d]:%d\n", i, evlst[i]));
           if( evlst[i] == 0 )
               break;
       }
       DEBUG_PRINT(("Settabletto() i = %d\n", i));
       if (XSelectExtensionEvent(bmp_plm->disp, rwin, evlst, i))
       {                       /*  XNextEvent Ǽ褦ˤƤ  */
           return(-1);
       }
    }

    return(1);
}

/*  ֥åꥦɥ  ѡĤͤ  */
void Cset_tabval(Widget w, int size, int *value)
{
  Arg args[1];
  char str[5];
  float  val;

  XtSetArg(args[0], XtNvalue, &str);
  XtGetValues(w, args, 1);

  val = (float)*value / 100;
  sprintf(str, "%3.2f", val);
  XtSetArg(args[0], XtNlabel, str);
  XtSetValues( w, args, XtNumber(args) );
}

/*  ֥åꥦɥ  ܥ塼ΰư  */
void Tabpnl_Evt(Widget w, caddr_t client_data, caddr_t percent_ptr)
{
  float percent = *(float*)percent_ptr;

  if(percent > 1)
      percent = 1;
  if(percent < 0)
      percent = 0;

  mangn = percent * 256;

  Cset_tabval(prgid->tabpnl.magn_siz, 1, &mangn);
                                                  /*  ѡĤͤ  */
}

/*  ǥХΥХå  */
void Select_device(Widget w, caddr_t client_data, caddr_t call_data)
{
  char *dev_name;
  XawListReturnStruct  *dev_ret;

  dev_ret = (XawListReturnStruct *)call_data;

  dev_name = dev_ret->string;
  dev_no = dev_ret->list_index;

}

/*  ֥åѥͥ 󥻥륳Хå  */
void Atab_cancel(Widget w, caddr_t client_data, caddr_t call_data)
{
  XtUnmanageChild( prgid->tabpnl.main_pnl );  /*  ѥͥĤ  */
}

/*  ֥åѥͥ ¹ԥХå  */
void Atab_ok(Widget w, caddr_t client_data, caddr_t call_data)
{
  String value;
  float  tabsc;
  int  err;

  XtVaGetValues( prgid->tabpnl.undr_siz, XtNstring, &value, NULL );
  XtVaGetValues( prgid->tabpnl.scroll,   XtNshown,  &tabsc, NULL );
  prgid->tabpnl.under = atoi(value);  /*  "­ڤ"ͤμФ  */
  if(prgid->tabpnl.under > 255)
  {    /*  255ޤ  */
    prgid->tabpnl.under = 255;
  }
  prgid->tabpnl.mangn = mangn;

  DEBUG_PRINT(("Atab_ok()  tabsc:%f\n", tabsc));

  DEBUG_PRINT(("Atab_ok()  tabpnl.under:%d  tabpnl.mangn:%d  dev_no:%d\n",
                           prgid->tabpnl.under, prgid->tabpnl.mangn, dev_no));

  if(dev_no >= 0)
 {
    err = Device_open(dev_no);  /*  ǥХΥץ  */
    if(err > 0)  /*  ֥åȻѲǽ  */
    {
      prgid->xb_mode |= 0x0010;
      DEBUG_PRINT(("Tabletto can use\n"));
    }
    else
      prgid->xb_mode &= 0xffef;
  }

  XtUnmanageChild( prgid->tabpnl.main_pnl );  /*  ѥͥĤ  */
}

/* XInput ΥǥХΥꥹȤǼ */
void Devicelist(PRGID *prg_id)
{
  Arg  args[2];
  Display	*disp;

  char dir_buf[256];
  int i, num_dev;

  dev_no = -1;  /*  򤷤ƤǥХꥻåȤ  */
  num_dev = 0;

  disp = XOpenDisplay(NULL);
  infobuf = XListInputDevices(disp, &num_dev);
                    /*   X-Window ǻѤǤǥХĴ٤Ƥ  */

  listdev = (String *) XtMalloc( sizeof( String * ) * num_dev + 1 );

  for(i = 0; i < num_dev; i ++)
  {                  /*  ǥХ򸵤˥ꥹȤ  */
    DEBUG_PRINT(("device XID:%d name:%s use:%d\n",
                    infobuf[i].id, infobuf[i].name, infobuf[i].use));
    listdev[i] = XtNewString(infobuf[i].name);
  }
  listdev[i] = NULL;

  XawListChange( prgid->tabpnl.dev_lst, listdev, 0, 0, True );

  XtSetArg( args[0], XtNwidth, (XtArgVal)300);
  XtSetArg( args[1], XtNheight, (XtArgVal)800);
  XtSetValues( prgid->tabpnl.dev_lst, args, XtNumber(args) );
  /*  ΤǥꥹȥåȤ礭ꤷʤȡ
      ٤ƤιܤɽʤäꡢܤɽƤΤˤ
      餺СФޤޤˤʤäꤹ  */

  return;
}


/*  ֥åѥͥκ  */
Widget  Tablettomenu(CONSPATS *cons_parts, PRGID *prg_id)
{
  int horiz, vert;
  RECT rect;
  Widget  main_box;

  static  char  defaultTranslations[] =
    "<Btn1Down> : StartScroll(Continuos)MoveThumb()NotifyThumb() \n\
     <Btn1Motion> : MoveThumb()NotifyThumb()";
  XtTranslations trans_table;

  static  XtCallbackRec  callback[] =
  { {(XtCallbackProc)Tabpnl_Evt, NULL},
    {NULL, NULL},
  };

  Wget_wrk(prg_id->pwid, &rect);  /*  ɥɽΰΰ  */

  horiz = ((rect.c.right - rect.c.left) - 200) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 150) / 2;

  main_box = XtVaCreateWidget("automaskbox", formWidgetClass,
                            prg_id->pwid,
			    XtNborderWidth, 4,
			    XtNwidth, 200,
			    XtNheight, 240,
			    XtNhorizDistance, (XtArgVal)horiz,
			    XtNvertDistance,  (XtArgVal)vert,
			    XtNtop,    XtChainTop,
			    XtNbottom, XtChainTop,
			    XtNleft,   XtChainLeft,
			    XtNright,  XtChainLeft,
 			    XtNbackground,  GRAY,
			    NULL);

  tab_paned = XtVaCreateManagedWidget("paned", panedWidgetClass,
                                   main_box, 
				   XtNborderWidth, 1,
			           XtNhorizDistance, 10,
			           XtNvertDistance,  40,
				   XtNwidth,       180,
				   XtNheight,      80, 
 			           XtNbackground,  LGRAY,
				   NULL);

  tab_vport  = XtVaCreateManagedWidget("vport", viewportWidgetClass,
				   tab_paned,
				   XtNallowHoriz, TRUE,
				   XtNallowVert, TRUE,
				   XtNuseBottom, TRUE,
				   XtNuseRight, TRUE,
				   XtNfont,   info,
 			           XtNbackground,  LGRAY,
				   NULL);

  prg_id->tabpnl.dev_lst = XtVaCreateManagedWidget("drvList", listWidgetClass,
				       tab_vport,
				       XtNfont,   info,
   			               XtNbackground,  LGRAY,
				       NULL);

  prg_id->tabpnl.undr_siz = XtVaCreateManagedWidget("undr",
                                     asciiTextWidgetClass,
                                     main_box,
			             XtNhorizDistance, 150,
			             XtNvertDistance,  136,
				     XtNlength, 4,
				     XtNwidth,  35,
				     XtNheight, 20,
				     XtNeditType, XawtextEdit,
				     XtNfont,   info,
 			             XtNbackground,  LGRAY,
				     NULL);

  prg_id->tabpnl.scroll = XtVaCreateManagedWidget("scroll",
                                 scrollbarWidgetClass,
                                 main_box,
                                 XtNorientation,  (XtArgVal)XtorientHorizontal,
		                 XtNhorizDistance, (XtArgVal)5,
		                 XtNvertDistance,  (XtArgVal)182,
			         XtNwidth,     (XtArgVal)155,
			         XtNheight,    (XtArgVal)16,
		      	         XtNlength,    (XtArgVal)150,
			         XtNthickness, (XtArgVal)16,
                                 XtNjumpProc,  (XtArgVal)callback,
 			         XtNbackground,  DGRAY,
				 NULL);

  prg_id->tabpnl.magn_siz = XtVaCreateManagedWidget("magn_siz",
                                     labelWidgetClass,
                                     main_box,
			             XtNhorizDistance, 165,
			             XtNvertDistance,  180,
				     XtNlength, 3,
				     XtNwidth,  30,
				     XtNheight, 20,
				     XtNfont,   info,
 			             XtNbackground,  LGRAY,
				     NULL);

  prg_id->tabpnl.cansel = XtVaCreateManagedWidget("Cancel", commandWidgetClass,
                                     main_box,
 			             XtNlabel, (XtArgVal)"Cancel",
			             XtNhorizDistance, 30,
			             XtNvertDistance,  210,
				     XtNwidth,  44,
				     XtNheight, 20,
				     XtNfont,   info,
 			             XtNbackground,  LGRAY,
				     NULL);

  prg_id->tabpnl.okbt  = XtVaCreateManagedWidget("ok", commandWidgetClass,
                                     main_box,
 			             XtNlabel, (XtArgVal)"O  K",
			             XtNhorizDistance, 130,
			             XtNvertDistance,  210,
				     XtNwidth,  40,
				     XtNheight, 20,
				     XtNfont,   info,
 			             XtNbackground,  LGRAY,
				     NULL);

  trans_table = XtParseTranslationTable(defaultTranslations);
  XtOverrideTranslations(prg_id->tabpnl.scroll, trans_table);
                                      /*  ȥ󥹥졼ơ֥Ͽ  */

  XtAddCallback(prg_id->tabpnl.dev_lst, XtNcallback,
                (XtCallbackProc)Select_device, NULL);  /*  ǥХΥХåϿ  */
  XtAddCallback(prg_id->tabpnl.cansel, XtNcallback,
                (XtCallbackProc)Atab_cancel, NULL);  /*  󥻥ܥΥХåϿ  */
  XtAddCallback(prg_id->tabpnl.okbt, XtNcallback,
                (XtCallbackProc)Atab_ok, NULL);  /*  ϣ˥ܥΥХåϿ  */

  return(main_box);
}

/*  ֥åΥݥåץå  */
int  Tabletto_pnl(CONSPATS *cons_parts, PRGID *prg_id)
{
  int horiz, vert, len;
  RECT rect;
  Arg  args[2];
  Display *dsp;
  GC  gc;
  Font fnt1, fnt2;            /*  եȻ  */
  char str[3];

  DEBUG_PRINT(("Tabletto_pnl()\n"));
  Wget_wrk(prg_id->pwid, &rect);  /*  ɥɽΰΰ  */

  horiz = ((rect.c.right - rect.c.left) - 200) / 2;
  vert = ((rect.c.bottom - rect.c.top) - 150) / 2;
  XtSetArg( args[0], XtNhorizDistance, (XtArgVal)horiz);
  XtSetArg( args[1], XtNvertDistance, (XtArgVal)vert);
  XtSetValues( prg_id->tabpnl.main_pnl, args, XtNumber(args) );
                                              /*  ܥååȤ  */

  dsp = XtDisplay( prg_id->tabpnl.main_pnl );
  gc = DefaultGC( dsp, DefaultScreen( dsp ) );

  fnt1 = XLoadFont( dsp, "-*-bold-*--16-*" );
  fnt2 = XLoadFont( dsp, "-*-bold-*--13-*" );
                                        /* եȾФ  */
  XSetFont(dsp, gc, fnt2);  /*  եȤ򥻥åȤ  */
  XSetForeground(dsp, gc, BLACK);  /*  ʿ  */

  sprintf(str, "%3d", prg_id->tabpnl.under);
  Set_string_text( prg_id->tabpnl.undr_siz, str );
                                                  /*  ѡĤͤɽ  */

  Cset_tabval(prg_id->tabpnl.magn_siz, 1, &prg_id->tabpnl.mangn);
                                                  /*  ѡĤͤɽ  */

  XawScrollbarSetThumb( prg_id->tabpnl.scroll,
                                ((float)prg_id->tabpnl.mangn / 256), 0.0 );
                                                     /*  ܥ塼  */

  Devicelist(prg_id);  /* XInput ΥǥХΥꥹȤǼ */

  /*  ʸȤϡåȤɽƤǤʤȥ顼Ǥ  */
  XSetFont(dsp, gc, fnt1);  /*  եȤ򥻥åȤ  */
  len = strlen(tab_label[0]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prg_id->tabpnl.main_pnl ), gc,
                                      10, 25, tab_label[0], len );
  XSetFont(dsp, gc, fnt2);  /*  եȤ򥻥åȤ  */
  len = strlen(tab_label[1]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prg_id->tabpnl.main_pnl ), gc,
                                      32, 150, tab_label[1], len );
  len = strlen(tab_label[2]);       /*  ʸĹĴ٤  */
  XDrawString( dsp, XtWindow( prg_id->tabpnl.main_pnl ), gc,
                                      20, 176, tab_label[2], len );
  return(1);
}
